#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define eb emplace_back

const int N = 2e5 + 5;

vector<int> v[N];
int color[N];
int ans = 1;

void dfs(int x, int pr = -1) {
    ans = max(ans, color[x]);
    {
        set<int> f;
        if (pr != -1) f.insert(color[pr]);
        f.insert(color[x]);
        int it = 1;
        for (int to : v[x]) {
            if (to == pr) continue;
            while (f.count(it)) it++;
            color[to] = it++;
        }
    }
    for (int to : v[x]) {
        if (to == pr) continue;
        dfs(to, x);
    }
}

bool cmp(int x, int y) {
    return v[x].size() < v[y].size();
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        v[x].pb(y);
        v[y].pb(x);
    }
    for (int i = 1; i <= n; i++) {
        sort(v[i].begin(), v[i].end(), cmp);
    }
    color[1] = 1;
    dfs(1);
    cout << ans << endl;
    for (int i = 1; i <= n; i++) cout << color[i] << " ";
    return 0;
}
