#include <bits/stdc++.h>

#define mp make_pair
#define pb push_back
#define all(_container) (_container.begin(),_container.end())

#define forn(i,n) for (int (i) = 0; (i) < (int)(n); ++(i))
#define fordn(i,n) for (int (i) = (int)(n) - 1; (i) >= 0; --(i))
#define forkn(i,k,n) for (int (i) = (int)(k); (i) < (int)(n); ++(i))
#define forv(i,_container) for (auto (i) : (_container))

#define OUTPUT "output.txt"
#define INPUT "input1.txt"
#define FIN freopen(INPUT,"r",stdin)
#define FOUT freopen(OUTPUT,"w",stdout)

#ifndef HOME
#define FASTIO cin.tie(NULL); ios_base::sync_with_stdio(false);
#define cerr if (0) cerr
#define _DD if (0)
#define DD_
#else
#define FASTIO
#define _DD
#define DD_
#endif

#define MAXN 200100
#define INF 0x3f3f3f3f
#define INFLL 0x3f3f3f3f3f3f3f3fll
#define EPS 1e-7
#define MOD 1'000'000'007
#define HASHMOD 1791791791
#define M_PI 3.14159265359

using namespace std;

typedef int64_t ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pld;
typedef vector<int> vi;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<pll> vpll;
typedef vector<ld> vld;
typedef vector<pld> vpld;

typedef vector<vector<int>> graph;
typedef vector<vector<pii>> wgraph;

graph g,path;
int max_len;
int cur_i;

char used[MAXN];

void dfs(int v)
{
    used[v] = 1;
    path[cur_i].pb(v);
    if (path[cur_i].size() >= max_len)
        ++cur_i;

    forv(i,g[v])
    {
        if (!used[i])
        {
            dfs(i);
            path[cur_i].pb(v);
            if (path[cur_i].size() >= max_len)
                ++cur_i;
        }
    }
}

int main()
{
    FASTIO
    #ifdef HOME
    FIN;
    #endif // HOME

    int n,m,k;
    cin >> n >> m >> k;
    max_len = ((2 * n) / k + ((2 * n) % k != 0));

    g.resize(n);
    path.resize(k);
    forn(i,m)
    {
        int u,v;
        cin >> u >> v; --u, --v;
        g[u].pb(v);
        g[v].pb(u);
    }
    cur_i = 0;
    dfs(0);
    forn(i,k)
    {
        if (path[i].size() == 0)
            path[i].push_back(0);
        cout << path[i].size() << ' ';
        forv(j,path[i])
            cout << j+1 << ' ';
        cout << endl;
    }
}

