#include <bits/stdc++.h>

using namespace std;

#define fr first
#define sc second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int maxn = 2e5 + 55;
const int inf = 1e9;
const int base = 1e9 + 9;
const double eps = 1e-7;

int n;
vector<int> a[maxn];
int c[maxn];

void dfs(int v, int anc){
    int clr = 1;
    for(int i = 0; i < a[v].size(); i++){
        if(clr == c[anc])
            clr++;
        if(clr == c[v])
            clr++;
        if(c[a[v][i]] == 0){
            c[a[v][i]] = clr;
            clr++;
            dfs(a[v][i], v);
        }
    }
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin >> n;
    for(int i = 0; i < n; i++){
        int u, v;
        cin >> u >> v;
        u--; v--;
        a[v].pb(u);
        a[u].pb(v);
    }
    int ans = 0;
    c[0] = 1;
    dfs(0, 0);
    for(int i = 0; i < n; i++)
        ans = max(ans, c[i]);
    cout << ans << "\n";
    for(int i = 0; i < n; i++)
        cout << c[i] << " ";
    return 0;
}
