#include <bits/stdc++.h>

using namespace std;

#define fr first
#define sc second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int maxn = 2e5 + 55;
const int inf = 1e9;
const int base = 1e9 + 9;
const double eps = 1e-7;

int k, n, m, len;
vector<int> a[maxn];
bool used[maxn];
vector<int> q;

void dfs(int v){
    used[v] = 1;
    q.pb(v);
    for(int i = 0; i < a[v].size(); i++)
        if(!used[a[v][i]]){
            dfs(a[v][i]);
            q.pb(v);
        }
    if(q.back() != v)
        q.pb(v);

}

vector<int> nxt[maxn];
int d[maxn];

int main()
{
    ios_base::sync_with_stdio(0);
    cin >> n >> m >> k;
    for(int i = 0; i < m; i++){
        int v, u, t;
        cin >> v >> u;
        v--;
        u--;
        a[v].pb(u);
        a[u].pb(v);
    }
    len = (2*n + k - 1)/k;
    dfs(0);
    for(int i = 0; i < q.size(); i++){
        nxt[q[i]].pb(i);
    }
    for(int i = 0; i < n; i++){
        used[i] = 0;
        d[i] = 0;
        nxt[i].pb(q.size() + 1);
    }
    int cnt = 0;
    for(int i = 0; i < q.size(); i++){
        while(nxt[q[i]][d[q[i]]] <= i)
            d[q[i]]++;
        if((nxt[q[i]][d[q[i]]] >= i + len && !used[q[i]]) || nxt[q[i]][d[q[i]]] > q.size()){
            int j = 0;
            cout << min(len, (int)q.size() - i) << " ";
            for(j = i; j < i + len && j < q.size(); j++){
                cout << q[j] + 1  << " ";
                used[q[j]] = 1;
            }
            cout << "\n";
            cnt++;
            i = j - 1;
        }
    }
    while(cnt < k){
        cout << "1 1\n";
        cnt++;
    }
    return 0;
}
