#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <ctime>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <bitset>
#include <numeric>

using namespace std;

typedef long long ll;
typedef double ld;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int dd = (int)2e5 + 7;
const int inf = (int)1e9 + 7;

vector<int> G[dd];
vector<int> ans[dd];
int cnt = 0, used[dd], K;

void dfs(int v, int p = -1) {
	ans[cnt].push_back(v);
	used[v] = 1;
	if ((int)ans[cnt].size() == K)
		return;
	vector<int> P;
	for (int i = 0; i < (int)G[v].size(); ++i) if (G[v][i] != p) {
		if ((int)ans[cnt].size() == K) return;
		int to = G[v][i];
		if (!used[to])
			dfs(to, v);
		else
			P.push_back(to);
	}
	if ((int)ans[cnt].size() == K) return;
	for (int i = 0; i < (int)P.size(); ++i) {
		if ((int)ans[cnt].size() == K) return;
		int to = P[i];
		dfs(to, v);
	}
	if ((int)ans[cnt].size() == K) return;
	if (p != -1)
		ans[cnt].push_back(p);
}

int solve() {
	srand(23423);
	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);
	K = (2 * n + k - 1) / k;
	for (int i = 0; i < m; ++i) {
		int x, y;
		scanf("%d %d", &x, &y);
		--x, --y;
		G[x].push_back(y);
		G[y].push_back(x);
	}

	for (int i = 0; i < n; ++i)
		random_shuffle(G[i].begin(), G[i].end());

	for (int i = 0; i < n; ++i) if (!used[i]) {
		dfs(i), cnt++;
	}

	for (int i = 0; i < k; ++i) {
		if (!(int)ans[i].size())
			ans[i].push_back(0);
		printf("%d ", (int)ans[i].size());
		for (int ii = 0; ii < (int)ans[i].size(); ++ii)
			printf("%d ", ans[i][ii] + 1);
		puts("");
	}
	return 0;
}