#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <ctime>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <bitset>
#include <numeric>

using namespace std;

typedef long long ll;
typedef double ld;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int dd = (int)2e5 + 7;
const int inf = (int)1e9 + 7;

vector<int> G[dd];
vector<int> ans[dd];
int cnt[dd], K, us;
int used[dd];

int dfs_ans(int v, int p) {
	used[v] = 1;
	ans[us].push_back(v);
	int O = 1;
	for (int i = 0; i < (int)G[v].size(); ++i) {
		int to = G[v][i];
		if (!used[to] && to != p && (K - (int)ans[us].size()) >= 2 * cnt[to] - 1)
			O += dfs_ans(to, v);
	}
	if (p != -1) ans[us].push_back(p);
	return O;
}

void dfs(int v, int p = -1) {
	cnt[v] = 1;
	for (int i = 0; i < (int)G[v].size(); ++i) if (G[v][i] != p) {
		int to = G[v][i];
		if (!cnt[to])
			dfs(to, v);
		cnt[v] += cnt[to];
	}

	if (cnt[v] >= K / 2) {
		while (cnt[v] != 1)
			cnt[v] -= dfs_ans(v, p) - 1, us++;
		cnt[v] = 0;
	}
}

int solve() {
	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);
	K = (2 * n + k - 1) / k;
	for (int i = 0; i < m; ++i) {
		int x, y;
		scanf("%d %d", &x, &y);
		--x, --y;
		G[x].push_back(y);
		G[y].push_back(x);
	}

	dfs(0);

	for (int i = 0; i < k; ++i) {
		if (!(int)ans[i].size())
			ans[i].push_back(0);
		while ((int)ans[i].size() > K) ans[i].pop_back();
		printf("%d ", (int)ans[i].size());
		for (int ii = 0; ii < (int)ans[i].size(); ++ii)
			printf("%d ", ans[i][ii] + 1);
		puts("");
	}
	return 0;
}