#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define len(a) (int)((a).size())
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define all(a) (a).begin(), (a).end()
#define int long long
#define INF (int)(1e9)
#define double long double

const double EPS = 1e-9;

using namespace std;

vector<pair<int, int> > a;
int n;

double f(double x) {
    double ans = 0;
    forn(i, n) {
        ans = max(ans, fabs(a[i].f - x) / a[i].s) ;
    }
    return ans;
}

signed main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cout.precision(31);
    cin.tie(0);
    cin >> n;
    a.resize(n);
    forn(i, n) cin >> a[i].f;
    forn(i, n) cin >> a[i].s;
    sort(all(a));
    double l = a[0].f, r = a[n - 1].f;
    while (r - l > EPS) {
        double m1 = l + (r - l) / 3;
        double m2 = r - (r - l) / 3;
        if (f(m1) < f(m2)) {
            r = m2;
        }
        else {
            l = m1;
        }
    }
    cout << fixed << f(l) ;
    return 0;
}
