#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int n, m;
vector <int> v;
vector <vector <pair <int, int> > > g;

int main()
{
    v.push_back(0);
    for (int i = 0; i < 21; i++)
    {
        n = (int)v.size();
        for (int j = 0; j < n; j++)
            v.push_back(v[j] ^ 1);
    }
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n >> m;
    g.resize(n + 1);
    for (int i = 0; i < m; i++)
    {
        int from, to, type;
        cin >> from >> to >> type;
        g[from].push_back({to, type});
    }

    int step = 0;
    vector <vector <bool> > used(2, vector <bool>(n + 1, false));
    used[0][1] = true;

    int N = 620000000 / (n * n);
    for (int z = 0; z < min((int)v.size(), N); z++, step ^= 1)
    {
        bool check = false;
        for (int i = 1; i <= n; i++)
            if (used[step][i])
                check = true;

        if (!check)
            return cout << z - 1, 0;

        for (int i = 1; i <= n; i++)
        {
            if (!used[step][i])
                continue;
            for (int j = 0; j < (int)g[i].size(); j++)
            {
                int to = g[i][j].first, type = g[i][j].second;
                if (type == v[z])
                used[step ^ 1][to] = true;
            }
            used[step][i] = false;
        }
    }

    cout << -1;
    return 0;
}
