#include <bits/stdc++.h>

using namespace std;
const int N = 4e5 + 228;

int pos[N], v[N];

int n;

vector<int> g[N];
set<int> not_used[N];
int color[N];


void dfs(int v, int p = -1, int up_color = -1) {

    for(int i = 1; i <= g[v].size() + 20; i++) {
        not_used[v].insert(i);
    }

    not_used[v].erase(color[v]);
    not_used[v].erase(up_color);


    for(int i = 0; i < g[v].size(); i++) {
        int u = g[v][i];

        if(u == p)
            continue;

        color[u] = *not_used[v].begin();
        not_used[v].erase(not_used[v].begin());

        dfs(u, v, color[v]);
    }
}

int main() {
    ios::sync_with_stdio(false);
//    freopen(".in", "r", stdin);

    cin >> n;

    for(int i = 2; i <= n; i++) {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);

    }

    color[1] = 1;

    dfs(1);

    int mx = 0;
    for(int i = 1; i <= n; i++) {
        mx = max(mx, color[i]);
    }


    cout << mx << "\n";

    for(int i = 1; i <= n; i++) {
        cout << color[i] << " ";
    }
    cout << '\n';


    return 0;
}
