#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
const int MAXN = 2 * 1e5 + 100;

int n;
vector<int> g[MAXN];
set<int> inter;
int clr[MAXN];

void dfs(int v, int prev){
    vector<int> pb;

    if (clr[v] != -1){
        inter.erase(clr[v]);
        pb.push_back(clr[v]);
    }

    if (clr[prev] != -1){
        inter.erase(clr[prev]);
        pb.push_back(clr[prev]);
    }

    vector<pair<int, int>> for_dfs;
    for (auto to : g[v]){
        if (to != prev){
            for_dfs.push_back({to, *inter.begin()});
            clr[to] = *inter.begin();
            inter.erase(inter.begin());
        }
    }

    for (auto e : pb){
        inter.insert(e);
    }

    for (auto e : for_dfs){
        inter.insert(e.second);
    }

    for (auto e : for_dfs){
        dfs(e.first, v);
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    for (int i = 0; i < n - 1; ++i){
        int v1, v2;
        cin >> v1 >> v2;
        v1--;
        v2--;

        g[v1].push_back(v2);
        g[v2].push_back(v1);
    }

    for (int i = 0; i <= n; ++i){
        inter.insert(i);
        clr[i] = -1;
    }

    clr[0] = 0;
    dfs(0, 0);

    int max_c = 0;
    for (int i = 0; i < n; ++i){
        max_c = max(max_c, clr[i]);
    }

    cout << max_c + 1 << endl;

    for (int i = 0; i < n; ++i){
        cout << clr[i] + 1 << ' ';
    }
    cout << endl;

    return 0;
}
