#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
const int MAXN = 1e5 * 2 + 100;
const long long MAXST = 61;
const long long INF = 1e18;

int n, m;
set<int> g_p[MAXN];
set<int> g_v[MAXN];

bool used_dp[MAXN][MAXST][2];
set<int> dp[MAXN][MAXST][2];

set<int> pereh(set<int> cur_sost, int st, int tp);

set<int> rec(int v, int st, int tp){
    if (used_dp[v][st][tp]){
        return dp[v][st][tp];
    }

    used_dp[v][st][tp] = true;

    if (tp == 0){
        if (st == 0){
            dp[v][st][tp] = g_p[v];
            return dp[v][st][tp];
        }

        dp[v][st][tp] = pereh(rec(v, st - 1, tp), st - 1, 1);
        return dp[v][st][tp];
    } else {
        if (st == 0){
            dp[v][st][tp] = g_v[v];
            return dp[v][st][tp];
        }

        dp[v][st][tp] = pereh(rec(v, st - 1, tp), st - 1, 0);
        return dp[v][st][tp];
    }
}

set<int> pereh(set<int> cur_sost, int st, int tp){
    set<int> ans;

    if (cur_sost.size() > 0){
        for (auto e : cur_sost){
            //cout << e << ' ';
            set<int> kek = rec(e, st, tp);
            for (auto k : kek){
                //cout << k << ' ';
                ans.insert(k);
            }
            //cout << endl;
        }
    }

    return ans;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m;

    for (int i = 0; i < m; ++i){
        int v, to, tp;
        cin >> v >> to >> tp;
        v--;
        to--;

        if (tp == 0){
            g_p[v].insert(to);
        } else {
            g_v[v].insert(to);
        }
    }

    for (int i = 0; i < MAXN; ++i){
        for (int j = 0; j < MAXST; ++j){
            used_dp[i][j][0] = false;
            used_dp[i][j][1] = false;
        }
    }

    set<int> cur_sost;
    cur_sost.clear();
    int cur_ch = 0;
    cur_sost.insert(0);

    long long ans_len = 0;

    for (int i = MAXST - 1; i >= 0; --i){
        set<int> next_per = pereh(cur_sost, i, cur_ch);
        //cout << i << "KEK" << endl;
        if (next_per.size() > 0){
            ans_len += (((long long)1) << ((long long)i));
            cur_sost = next_per;
            cur_ch ^= 1;
        }
    }

    set<int> next_per = pereh(cur_sost, 0, cur_ch);
    if (next_per.size() > 0){
        ans_len += (((long long)1) << ((long long)0));
        cur_sost = next_per;
    }

    if (ans_len > INF){
        cout << -1 << endl;
    } else {
        cout << ans_len << endl;
    }

    return 0;
}
