#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <vector>
#	include <string>
#	include <algorithm>
#	include <functional>
#	include <iomanip>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ld DEL = 1e-7;

void dfs(int s, vector<vector<int>> &a, vector<int> &col, int c, int c1, int prev)
{
	col[s] = c;

	int cur_c = 0;
	for (int i = 0; i < a[s].size(); i++)
		if (a[s][i] != prev)
		{
			while (cur_c == c || cur_c == c1)
				cur_c++;

			dfs(a[s][i], a, col, cur_c, c, s);

			cur_c++;
		}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int n;
	cin >> n;

	vector<vector<int>> a(n);
	for (int i = 1; i < n; i++)
	{
		int u, v;
		cin >> u >> v;

		a[u - 1].push_back(v - 1);
		a[v - 1].push_back(u - 1);
	}

	int res = 0;
	for (int i = 0; i < n; i++)
		if (a[i].size() + 1 > res)
			res = a[i].size() + 1;

	cout << res << endl;

	vector<int> col(n);
	dfs(0, a, col, 0, -1, -1);

	for (int i = 0; i < n; i++)
		cout << col[i] + 1 << ' ';
}