#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <vector>
#	include <string>
#	include <algorithm>
#	include <functional>
#	include <iomanip>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

vector<int> res;
void dfs(int s, vector<vector<int>> &a, vector<int> &v)
{
	res.push_back(s);
	v[s] = 1;

	for (int i = 0; i < a[s].size(); i++)
		if (!v[a[s][i]])
		{
			dfs(a[s][i], a, v);
			res.push_back(s);
		}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<int>> a(n);
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;

		a[u - 1].push_back(v - 1);
		a[v - 1].push_back(u - 1);
	}

	vector<int> v(n, 0);
	dfs(0, a, v);

	int p = 0;
	for (int i = 0; i < k; i++)
	{
		int l = max(1, min((int)(res.size() - p), (2 * n + k - 1) / k));
		cout << l << ' ';

		for (int j = 0; j < l; j++)
			if (p < res.size())
			{
				cout << res[p] + 1 << ' ';
				p++;
			}
			else
				cout << res.back() + 1 << ' ';

		cout << endl;
	}
}