#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <vector>
#	include <string>
#	include <algorithm>
#	include <functional>
#	include <iomanip>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

int get_t(int n)
{
	int cnt = 0;
	while (n > 0)
	{
		n = n & (n - 1);
		cnt++;
	}

	return cnt % 2;
}

int dfs(int s, vector<vector<vector<int>>> &a, vector<int> &f, vector<int> &last_v, vector<int> &last_c, int d)
{
	if (f[s])
		return -1;

	int type = get_t(d), res = d;
	for (int i = 0; i < a[type][s].size(); i++)
	{
		int t = dfs(a[type][s][i], a, f, last_v, last_c, d + 1);

		if (t == -1)
			return -1;

		if (t > res)
			res = t;
	}

	return res;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int n, m;
	scanf("%d %d", &n, &m);

	vector<vector<vector<int>>> a(2, vector<vector<int>>(n));
	for (int i = 0; i < m; i++)
	{
		int u, v, t;
		cin >> u >> v >> t;

		a[t][u - 1].push_back(v - 1);
	}

	vector<int> f(n, 0);
	for (int i = 0; i < n; i++)
	{
		int f1 = 0, f2 = 0;

		for (int j = 0; j < a[0][i].size(); j++)
			if (a[0][i][j] == i)
				f1 = 1;

		for (int j = 0; j < a[1][i].size(); j++)
			if (a[1][i][j] == i)
				f2 = 1;

		f[i] = f1 && f2;
	}

	vector<int> _a(n, -1), _b(n, -1);
	printf("%d\n", dfs(0, a, f, _a, _b, 0));
}