#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <complex>

using namespace std;

vector < vector < int > > g;
vector < int > ans, us;

void dfs(int v) {
	us[v] = 1;
	ans.push_back(v);
	for (int i = 0; i < g[v].size(); i++) {
		if (!us[g[v][i]]) {
			dfs(g[v][i]);
			ans.push_back(v);
		}
	}
	return;
}

int main(){
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n, m, k;
	cin >> n >> m >> k;

	g.resize(n);

	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	us.resize(n, 0);

	dfs(0);

	vector < vector < int > > ot;
	ot.push_back(vector < int > ());
	int mx = (2 * n - 1) / k + 1;
	for (int i = 0; i < ans.size(); i++) {
		int x = ans[i];
		if (ot.back().size() >= mx)
			ot.push_back(vector < int > ());
		ot[ot.size() - 1].push_back(x);
	}

	for (int i = 0; i < ot.size(); i++) {
		cout << ot[i].size() << ' ';
		for (int j = 0; j < ot[i].size(); j++)
			cout << ot[i][j] + 1 << ' ';
		cout << '\n';
	}

	for (int i = ot.size(); i < k; i++)
		cout << "1\n";


	return 0;
}