#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <complex>

using namespace std;



int main(){
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector < pair < pair < int, int >, int > > edges(m);

	for (int i = 0; i < m; i++) {
		cin >> edges[i].first.first >> edges[i].first.second >> edges[i].second;
		edges[i].first.first--;
		edges[i].first.second--;
	}
	int MX = 60;
	vector < vector < vector < int > > > go(n, vector < vector < int > > (MX, vector < int > (2, -1)));

	for (int i = 0; i < m; i++)
		go[edges[i].first.first][0][edges[i].second] = edges[i].first.second;

	for (int i = 1; i < MX; i++) {
		for (int j = 0; j < n; j++) {
			for (int t = 0; t < 2; t++) {
				int pr = go[j][i - 1][t];
				if (pr == -1)
					continue;
				go[j][i][t] = go[pr][i - 1][!t];
			}
		}
	}

	unsigned long long mx = 0;
	const unsigned long long INF = 1e18;

	for (int i = 0; i < n; i++) {
		unsigned long long d = 0;
		int ty = 0, cur = i;
		while (1) {
			bool ch = 0;
			for (long long j = MX - 1; j >= 0; j--) {
				int to = go[cur][j][ty];
				if (to == -1)
					continue;
				ch = 1;
				d += (1ll << j);
				if (d > INF) {
					cout << -1;
					return 0;
				}
				cur = to;
				ty ^= 1;
				break;
			}
			if (!ch)
				break;
		}
		mx = max(mx, d);
	}

	

	cout << mx;


	return 0;
}