#include <iostream>
#include <vector>

using namespace std;

#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define pii pair <int, int>


vector <vector <int> > g;
vector <int> col;

void dfs(int v, int prev, int pc) {
	int cnt = 1;
	while (cnt == col[v] || cnt == pc)
		cnt++;
	for (int u : g[v]) {
		if (u == prev)
			continue;
		col[u] = cnt;
		dfs(u, v, col[v]);
		cnt++;
		while (cnt == col[v] || cnt == pc)
			cnt++;
	}
} 



int main() {
	int n;
	cin >> n;
	g.resize(n);
	col.resize(n, -1);
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].pb(v); g[v].pb(u);
	}

	col[0] = 1;
	dfs(0, -1, -1);
	int k = 0;
	for (auto i : col)
		k = max(k, i);
	cout << k << endl;
	for (auto & i : col)
		cout << i << ' ';
	cout << endl;
}