#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define pii pair <int, int>

vector <vector <int> > g;
vector <bool> used;
vector <int> ans;

void dfs(int v) {
	ans.pb(v);
	used[v] = 1;
	for (int u : g[v]) {
		if (!used[u]) {
			dfs(u);
			ans.pb(v);
		}
	}
}

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	g.resize(n);
	used.resize(n, false);
	while (m--) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].pb(v); g[v].pb(u);
	}
	dfs(0);
	int bad = (2 * n + k - 1) / k, cnt = 0;
	vector <vector <int> > by(k);
	for (auto i : ans) {
		if (by[cnt].size() == bad)
			cnt++;
		by[cnt].pb(i);
	}
	for (int i = 0; i < k; ++i) {
		if (by[i].size() == 0) {
			cout << "1 1\n";
			continue;
		}
		cout << by[i].size() <<  ' ';
		for (auto j : by[i])
			cout << j + 1 << ' ';
		cout << endl;
	}
}