#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define endl '\n'
#define fi first
#define se second

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> & p)
{
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (auto & i: arr)
    {
        in >> i;
    }
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (int i = 0; i < (int)arr.size() - 1; ++i)
        out << arr[i] << " ";
    if (arr.size())
        out << arr.back();
    return out;
}

template <typename T1, typename T2>
T1 min(T1 a, T2 b)
{
    return min(a, (T1) b);
}

template <typename T1, typename T2, typename T3>
T1 min(T1 a, T2 b, T3 c)
{
    return min(a, (T1)min(b, c));
}

template <typename T1, typename T2, typename T3, typename T4>
T1 min(T1 a, T2 b, T3 c, T4 d)
{
    return min(min(a, b), min(c, d));
}

template <typename T1, typename T2>
T1 max(T1 a, T2 b)
{
    return max(a, (T1) b);
}

template <typename T1, typename T2, typename T3>
T1 max(T1 a, T2 b, T3 c)
{
    return max(a, (T1)max(b, c));
}

template <typename T1, typename T2, typename T3, typename T4>
T1 max(T1 a, T2 b, T3 c, T4 d)
{
    return max(max(a, b), max(c, d));
}

vector <vector <int> > g;
vector <int> color;

void dfs(int v, int pr = -1)
{
    int clr = 1;
    for (auto u : g[v])
    {
        if (u == pr)
            continue;
        if (clr == color[v] || (pr != -1 && clr == color[pr]))
        {
            clr++;
        }
        if (clr == color[v] || (pr != -1 && clr == color[pr]))
        {
            clr++;
        }
        color[u] = clr;
        clr++;
        dfs(u, v);
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n;
    cin >> n;
    g.resize(n);
    color.resize(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    color[0] = 1;
    dfs(0);
    int mx = 0;
    for (int i = 0; i < n; ++i)
        mx = max(mx, color[i]);
    cout << mx << endl;
    cout << color << endl;
    return 0;
}
