/*
СТРОИМ СТЕНУ РАБОТЯГИ!
█▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀█
█═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═█
█═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═█
█═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═█
█═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═█
█═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═█
█═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═█
█═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═█
█═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═█
█▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄█
*/
#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdio>
#include <numeric>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <cmath>
#include <bitset>
#include <cassert>
#include <queue>
#include <stack>
#include <deque>



using namespace std;


template<typename T1, typename T2>inline void chkmin(T1 &x, T2 y) { if (x > y) x = y; }
template<typename T1, typename T2>inline void chkmax(T1 &x, T2 y) { if (x < y) x = y; }
/** Interface */

inline int readChar();
template <class T = int> inline T readInt();
template <class T> inline void writeInt( T x, char end = 0 );
inline void writeChar( int x );
inline void writeWord( const char *s );

/** Read */

static const int buf_size = 4096;

inline int getChar() {
    static char buf[buf_size];
    static int len = 0, pos = 0;
    if (pos == len) {
        pos = 0, len = fread(buf, 1, buf_size, stdin);
    }
    if (pos == len) {
        return -1;
    }
    return buf[pos++];
}

inline int readChar() {
    int c = getChar();
    while (c <= 32) {
        c = getChar();
    }
    return c;
}

template <class T>
inline T readInt() {
    int s = 1, c = readChar();
    T x = 0;
    if (c == '-')
        s = -1, c = getChar();
    while ('0' <= c && c <= '9')
        x = x * 10 + c - '0', c = getChar();
    return s == 1 ? x : -x;
}

/** Write */

static int write_pos = 0;
static char write_buf[buf_size];

inline void writeChar( int x ) {
    if (write_pos == buf_size)
        fwrite(write_buf, 1, buf_size, stdout), write_pos = 0;
    write_buf[write_pos++] = x;
}

template <class T>
inline void writeInt( T x, char end ) {
    if (x < 0)
        writeChar('-'), x = -x;

    char s[24];
    int n = 0;
    while (x || !n)
        s[n++] = '0' + x % 10, x /= 10;
    while (n--)
        writeChar(s[n]);
    if (end)
        writeChar(end);
}

inline void writeWord( const char *s ) {     while (*s)
writeChar(*s++); }

struct Flusher {
    ~Flusher() {
        if (write_pos)
            fwrite(write_buf, 1, write_pos, stdout), write_pos = 0;
    }
} flusher;

using namespace std;


#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
const int MAXN = 200001;


int n, m, k;
vector<int> g[MAXN];
bool used[MAXN];
vector<vector<int> > ans;


void dfs(int u, vector<int> &a) {
    used[u] = 1;
    vector<vector<int> > bad;
    for (auto h: g[u]) {
        if (!used[h]) {
            vector<int> t;
            dfs(h, t);
            if (sz(t) == (2 * n + k - 1) / k) {
                ans.push_back(t);
            } else {
                if (a.empty() || sz(a) > sz(t)) {
                    if (!a.empty()) {
                        bad.push_back(a);
                    }
                    swap(a, t);
                } else {
                    bad.push_back(t);
                }
            }
        }
    }
    vector<pair<int, int> > v;
    for (int i = 0; i < sz(bad); i++) {
        v.push_back(make_pair(sz(bad[i]), i));
    }
    sort(all(v));
    reverse(all(v));
    while (sz(v) >= 2) {
        if (sz(bad[v.back().second]) + sz(bad[v[sz(v) - 2].second]) + 1 <= (2 * n + k - 1) / k) {
            vector<int> v1;
            for (auto x: bad[v.back().second]) {
                v1.push_back(x);
            }
            v1.push_back(u);
            for (int i = sz(bad[v[sz(v) - 2].second]) - 1; i >= 0; i--) {
                v1.push_back(bad[v[sz(v) - 2].second][i]);
            }
            ans.push_back(v1);
            v.pop_back();
            v.pop_back();
        } else {
            break;
        }
    }
    for (auto x: v) {
        ans.push_back(bad[x.second]);
    }
    a.push_back(u);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<int> s;
    dfs(0, s);
    ans.push_back(s);
    int uk = sz(ans) - 1;
    while (sz(ans) < k) {
        while (sz(ans[uk]) == 1) {
            uk--;
        }
        vector<int> nv;
        nv.push_back(ans[uk].back());
        ans[uk].pop_back();
        ans.push_back(nv);
    }
    for (int i = 0; i < k; i++) {
        cout << sz(ans[i]) << ' ';
        for (auto x: ans[i]) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
    }
    return 0;
}
