#include <bits/stdc++.h>

using namespace std;
vector <vector <int> > adl;
vector <int> deg;
vector <int> color;

void dfs(int v, int col, int prevcol) {
    color[v] = col;
    int k = 0;
    for (int i = 0; i < adl[v].size(); ++i) {
        int u = adl[v][i];
        if (color[u] == -1) {
            if (k == col || k == prevcol) ++k;
            if (k == col || k == prevcol) ++k;
            dfs(u, k, col);
            ++k;
        }
    }
}

int main() {
    int n;
    cin >> n;
    deg.assign(n, 0);
    adl.resize(n);
    color.assign(n, -1);
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        adl[x - 1].push_back(y - 1);
        adl[y - 1].push_back(x - 1);
        deg[x - 1] += 1;
        deg[y - 1] += 1;
    }
    int maxx = 0;
    for (int i = 0; i < n; ++i) maxx = max(maxx, deg[i]);
    ++maxx;
    dfs(0, 0, -1);
    cout << maxx << endl;
    for (int i = 0; i < n; ++i) {
        cout << color[i] + 1 << " ";
    }
}
