#include <bits/stdc++.h>

using namespace std;
const unsigned long long MOD = 1e9 + 7;
const int INF = (int)2e9 + 7;
const long long LINF = (long long)1e18;
const unsigned long long mod1 = 183453789;
const unsigned long long mod2 = 1234567891;
const int P1 = 337, P2 = 263;

template<typename T>
T input(){
    T ans = 0, m = 1; char c = ' ';
    while (!((c >= '0' && c <= '9') || c == '-')) c = getchar();
    if (c == '-') m = -1, c = getchar();
    while (c >= '0' && c <= '9') ans = ans * 10 + (c - '0'), c = getchar();
    return ans * m;
}

string nextString(bool flag = false){
    char ch; string ans = "";
    do { ch = getchar(); } while(ch <= ' ');
    while(1) {
        ans += ch; ch = getchar();
        if ( (!flag && ch <= ' ') || (flag && ch < ' ') ) break;
    }
    return ans;
}
char nextChar(){
    char ch;
    do {ch = getchar(); } while(ch <= ' ');
    return ch;
}
void read(string& s){ s = nextString(); }
void read(char& c){ c = nextChar(); }
template<typename T> void read(T& a){ a = input<T>(); }
template<typename T, typename... R> void read(T& a, R&... r){ read(a); read(r...); }

const int N = 6e4 + 10;
int x[N], v[N];
int n;

bool can(long double t){
    long double L = -LINF, R = LINF;
    for (int i = 0; i < n; ++ i){
        L = max(L, (long double)x[i] - v[i] * t);
        R = min(R, (long double)x[i] + v[i] * t);
    }
    return L <= R;
}

int32_t main() {
    ios_base::sync_with_stdio(0);  cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    read(n);
    for (int i = 0; i < n; ++ i){
        read(x[i]);
    }
    for (int i = 0; i < n; ++ i){
        read(v[i]);
    }
    double l = 0, r = INF;
    for (int it = 60; it; -- it){
        double m = (l + r) / 2;
        if (can(m)){
            r = m;
        } else {
            l = m;
        }
    }
    cout.precision(12);
    cout << fixed << l;
}
