#include <bits/stdc++.h>

using namespace std;
const unsigned long long MOD = 1e9 + 7;
const int INF = (int)2e9 + 7;
const long long LINF = (long long)1e18;
const unsigned long long mod1 = 183453789;
const unsigned long long mod2 = 1234567891;
const int P1 = 337, P2 = 263;

template<typename T>
T input(){
    T ans = 0, m = 1; char c = ' ';
    while (!((c >= '0' && c <= '9') || c == '-')) c = getchar();
    if (c == '-') m = -1, c = getchar();
    while (c >= '0' && c <= '9') ans = ans * 10 + (c - '0'), c = getchar();
    return ans * m;
}

string nextString(bool flag = false){
    char ch; string ans = "";
    do { ch = getchar(); } while(ch <= ' ');
    while(1) {
        ans += ch; ch = getchar();
        if ( (!flag && ch <= ' ') || (flag && ch < ' ') ) break;
    }
    return ans;
}
char nextChar(){
    char ch;
    do {ch = getchar(); } while(ch <= ' ');
    return ch;
}
void read(string& s){ s = nextString(); }
void read(char& c){ c = nextChar(); }
template<typename T> void read(T& a){ a = input<T>(); }
template<typename T, typename... R> void read(T& a, R&... r){ read(a); read(r...); }

const int N = 2e5 + 10;
vector < int > g[N];
int col[N];

void dfs(int v, int p){
    int ptr = 0;
    for (auto to: g[v]){
        while (ptr == col[v] || (p != -1 && col[p] == ptr)) ptr ++;
        if (to == p) continue;
        col[to] = ptr;
        dfs(to, v);
        ptr ++;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);  cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n; read(n);
    for (int i = 0; i < n - 1; ++ i){
        int u, v;
        read(u, v);
        u --, v --;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int mx, id;
    mx = -1, id = -1;
    for (int i = 0; i < n; ++ i){
        if ((int)g[i].size() + 1 > mx){
            mx = g[i].size() + 1;
            id = i;
        }
    }
    cout << mx << "\n";
    memset(col, -1, sizeof col);
    col[id] = 0;
    dfs(id, -1);
    for (int i = 0; i < n; ++ i){
        cout << col[i] + 1 << " ";
    }
}
