#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>

using namespace std;

typedef int int32_t;
#define int long long

vector<vector<int> > edg;
vector<int> clr;
int mx = 0;

void dfs(int v, int p = -1) {
	int c = 0;
	for (int i = 0; i < edg[v].size(); i++) {
		int to = edg[v][i];
		if (to == p)
			continue;
		while ((p != -1 && c == clr[p]) || (c == clr[v]))
			c++;
		clr[to] = c;
		c++;
		mx = max(mx, c);
	}
	
	for (int i = 0; i < edg[v].size(); i++) {
		int to = edg[v][i];
		if (to == p)
			continue;
		dfs(to, v);
	}
}

int32_t main() {
	//freopen("input.in", "r", stdin);
	int n;
	cin >> n;
	edg.resize(n);
	clr.assign(n, -1);
	clr[0] = 0;
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		edg[u].push_back(v);
		edg[v].push_back(u);
	}
	dfs(0);
	cout << mx << "\n";
	for (int i = 0; i < n; i++)
		cout << clr[i] + 1 << " ";
}