#include <bits/stdc++.h>

using namespace std;

#define rep(i,a,n) for(int (i)=(a);(i)<(n);++(i))
#define per(i,a,n) for(int (i)=(n)-1;(i)>=(a);++(i))
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
#define SZ(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef vector<pii> vpii;

template <typename T>
T getint(){
    T x=0,p=1;
    char ch;
    do{ch=getchar();}while(ch<=' ');
    if(ch=='-')p=-1,ch=getchar();
    while(ch>='0'&&ch<='9'){
        x=x*10+ch-'0';ch=getchar();
    }
    return x*p;
}

mt19937 gen(std::chrono::system_clock::now().time_since_epoch().count());

template <typename T1,typename T2> bool umin(T1 &x, const T2&y) { if(x>y)return x=y,true; return false;}
template <typename T1,typename T2> bool umax(T1 &x, const T2&y) { if(x<y)return x=y,true; return false;}

const int maxn=(int)1e6+10;
const int inf=(int)1e9+5;
const int mod=(int)1e9+7;
const ll llinf=(ll)1e18+5;
const ld pi=acos(-1.0);

vector<int> g[maxn];
int cnt;
bool was[maxn];
int sz[maxn];

int par[maxn];

int get(int x){
    if(x==par[x])return x;
    return par[x]=get(par[x]);
}

bool unite(int x,int y){
    x=get(x),y=get(y);
    if(x==y)return false;
    par[x]=y;
    return true;
}

void dfs(int v,int par){
    sz[v]=1;
    for(int x:g[v]){
        if(x==par)continue;
        dfs(x,v);
        sz[v]+=sz[x];
    }
}

vi answer;

int traverse(int v,int par){
    int c=1;
    was[v]=true;
    for(int x:g[v]){
        if(x==par)continue;
        answer.pb(v);
        c+=traverse(x,v);
    }
    answer.pb(v);
    return c;
}

int main() {
   // freopen("input.txt","r",stdin);
   // //freopen("output.txt","w",stdout);

    ios_base::sync_with_stdio(0);
    int n,m,k;
    cin>>n>>m>>k;
    cnt=(n+n+k-1)/k;
    rep(i,1,n+1)par[i]=i;
    rep(i,0,m){
        int x,y;
        cin>>x>>y;
        if(unite(x,y)){
            g[x].pb(y);
            g[y].pb(x);
        }
    }
    dfs(1,-1);
    traverse(1,-1);
    int p=0;
    while(answer.size()<k*cnt){
        if(p%2==0)answer.pb(g[1][0]);
        else answer.pb(1);
        p^=1;
    }
    int ptr=0;
    rep(i,0,k){
        cout<<cnt<<' ';
        rep(j,0,cnt)cout<<answer[ptr++]<<' ';
        cout<<'\n';
    }

    return 0;
}
