# include <iostream>
# include <vector>
# include <cstdio>
# include <string>
# include <set>
# include <algorithm>
# include <cstring>

using namespace std;

const int MAX_N = 1000, ALP = 26;
pair<string, pair<string, pair<string, int> > > all[MAX_N];
string ans[MAX_N];
bool used[ALP];

bool check(const set<int> &beer)
{
    for (int i1 : beer)
    {
        if ((used[all[i1].second.second.first[0] - 'A'] ^ used[all[i1].second.first[0] - 'A'])) return true;
    }
    return false;
}

int main()
{
  //  freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    string s1, s2;
    for (int i = 0; i < n; i++)
    {
        cin >> s1 >> s2;
        all[i] = {s1.substr(0, 2), {s1.substr(2, 1), {s2.substr(0, 1), i}}};
    }
    sort(all, all + n);
    int i = 0;
    set<int> beer;
    while (i < n)
    {
        beer.clear();
        int j = i;
        while (j < n && all[i].first == all[j].first) ++j;
        memset(used, 0, ALP * sizeof(bool));
        int i1 = i;
        while (i1 < j)
        {
            int j1 = i1;
            while (j1 < j && all[i1].second.first == all[j1].second.first) ++j1;
            if (j1 - i1 == 1) beer.insert(i1);
            else
            {
                for (int t = i1; t < j1; t++)
                {
                    if (used[all[t].second.second.first[0] - 'A'])
                    {
                        cout << "NO";
                        return 0;
                    }
                    ans[all[t].second.second.second] = all[t].first + all[t].second.second.first;
                    used[all[t].second.second.first[0] - 'A'] = true;
                    used[all[t].second.first[0] - 'A'] = true;
                }
            }
            i1 = j1;
        }
        vector<int> bad;
        while (check(beer))
        {
            bad.clear();
            for (int i1 : beer)
            {
                if (used[all[i1].second.first[0] - 'A'] && used[all[i1].second.second.first[0] - 'A'])
                {
                    cout << "NO";
                    return 0;
                }
                if (used[all[i1].second.first[0] - 'A'])
                {
                    used[all[i1].second.second.first[0] - 'A'] = true;
                    ans[all[i1].second.second.second] = all[i1].first + all[i1].second.second.first;
                    bad.push_back(i1);
                }
                else if (used[all[i1].second.second.first[0] - 'A'])
                {
                    used[all[i1].second.first[0] - 'A'] = true;
                    ans[all[i1].second.second.second] = all[i1].first + all[i1].second.first;
                    bad.push_back(i1);
                }
            }
            for (int h : bad) beer.erase(h);
        }
        for (int i1 : beer)
        {
            if (used[all[i1].second.first[0] - 'A'] && used[all[i1].second.second.first[0] - 'A'])
            {
                cout << "NO";
                return 0;
            }
            if (used[all[i1].second.first[0] - 'A'])
            {
                used[all[i1].second.second.first[0] - 'A'] = true;
                ans[all[i1].second.second.second] = all[i1].first + all[i1].second.second.first;
            }
            else
            {
                used[all[i1].second.first[0] - 'A'] = true;
                ans[all[i1].second.second.second] = all[i1].first + all[i1].second.first;
            }
        }
        i = j;
    }
    cout << "YES\n";
    for (int i = 0; i < n; i++)
    {
        cout << ans[i] << "\n";
    }
    return 0;
}
