#define _CRT_SECURE_NO_WARNINGS
#define make_pair mp
#define push_back pb
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <queue>
#include <deque>
#include <set>
#include <string>
using namespace std;
typedef long double ld;
const int maxn = 5e3+5;
int col[maxn];
vector < int > gr[maxn];
int n;
vector < bool > used(maxn,false);
vector < bool > can(maxn,false);
vector < vector < int > > comp;
void retback(vector < int > &b){
	for(int i=0;i<b.size();i++){
		used[b[i]] = false;
		can[b[i]] = false;
	}
}
bool bfs(int v){
	used[v] = true;
	can[v] = true;
	queue < int > q;
	q.push(v);
	vector < int > b;
	while(!q.empty()){
		int x = q.front();
		b.pb(x);
		q.pop();
		if(can[x]){
			for(int i =0; i < gr[x].size();i++){
				int to = gr[x][i];
				if(can[to]){
					while(!q.empty()){
						b.pb(q.front());
						q.pop();
					}
					retback(b);
					return false;
				}
				if(!used[to]){
					used[to] = true;
					q.push(to);
				}
			}
		}
		else{
			int to;
			if(x > n){
				to = x - n;
			}
			else
				to = x + n;
			if(used[to]){
				if(!can[to]){
					while(!q.empty()){
						b.pb(q.front());
						q.pop();
					}
					retback(b);
					return false;
				}
			}
			else{
				q.push(to);
				used[to] = true;
				can[to] = true;
			}
		}
	}

	return true;
}

			
int main(){
#ifdef _DEBUG
	freopen("1_in.txt","r",stdin);
	freopen("1_out.txt","w",stdout);
#endif
	iostream::sync_with_stdio(false);
	cin.tie(NULL);
	//cout.precision(30);
	//cout<<fixed;
	cin >> n;
	vector < pair < string, string > > a(n+1);
	for(int i=1;i<=n;i++){
		string s;
		cin >> s;
		a[i].first=s.substr(0,3);
		cin >> s;
		a[i].second=a[i].first.substr(0,2)+s[0];
	}
	for(int i=1;i<=n;i++){
		gr[i].pb(i+n);
		gr[i+n].pb(i);
		for(int j=i+1;j<=n;j++){
			if(a[i].first==a[j].first){
				gr[i+n].pb(j);
				gr[j].pb(i+n);
				gr[j+n].pb(i);
				gr[i].pb(j+n);
				gr[i].pb(j);
				gr[j].pb(i);
			}
			if(a[i].first==a[j].second){
				gr[i].pb(j+n);
				gr[j+n].pb(i);
			}
			if(a[i].second==a[j].first){
				gr[i+n].pb(j);
				gr[j].pb(i+n);
			}
			if(a[i].second==a[j].second){
				gr[i+n].pb(j+n);
				gr[j+n].pb(i+n);
			}
		}
	}
	for(int i = 1;i<=n;i++){
		if(!used[i]){
			bool ok = bfs(i);
			if(!ok){
				ok = bfs(i+n);
				if(!ok){
					cout << "NO\n";
					return 0;
				}
			}
		}
	}
	cout << "YES\n";
	for(int i=1;i<=n;i++){
		if(can[i])
			cout << a[i].first << endl;
		else
			cout << a[i].second << endl;
	}

}