#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int> > mass[(int)4e5 + 10], arr[(int)4e5 + 10];

struct kek
{
    int h, l, r, s;
    kek(int h_ = 0, int l_ = 0, int r_ = 0, int s_ = 0): h(h_), l(l_), r(r_), s(s_) {}
    bool operator <(const kek a)const
    {
        return h < a.h;
    }
};

kek mas[(int)1e5 + 10];

void ins(int v, int l, int r, int q, int w, int a, int b, int id)
{
    if (l >= w || r <= q)
        return;
    if (q <= l && r <= w)
    {
        mass[v].push_back({a, id});
        mass[v].push_back({b, -id - 1});
        return;
    }
    int m = (l + r) / 2;
    ins(2 * v + 1, l, m, q, w, a, b, id);
    ins(2 * v + 2, m, r, q, w, a, b, id);
}

void init(int v, int l, int r)
{
    if (r - l > 1)
    {
        int m = (l + r) / 2;
        init(2 * v + 1, l, m);
        init(2 * v + 2, m, r);
    }
    sort(mass[v].begin(), mass[v].end());
    set<int> se;
    for (auto p: mass[v])
    {
        if (p.second >= 0)
            se.insert(p.second);
        else
            se.erase(-p.second - 1);
        if (se.size())
        {
            auto q = se.end();
            q--;
            arr[v].push_back({p.first, *q});
        }
        else
            break;
    }
}

int get(int v, int l, int r, int a, int b)
{
    int ans = 0;
    if (arr[v].size() > 0)
    {
        int le = 0, ri = arr[v].size();
        while (ri - le > 1)
        {
            int mi = (le + ri) / 2;
            if (arr[v][mi].first <= b)
                le = mi;
            else
                ri = mi;
        }
        ans = arr[v][le].second;
    }
    if (r - l > 1)
    {
        int m = (l + r) / 2;
        if (a < m)
            ans = max(ans, get(2 * v + 1, l, m, a, b));
        else
            ans = max(ans, get(2 * v + 2, m, r, a, b));
    }
    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int h, w, n;
    cin >> h >> w >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> mas[i].h >> mas[i].l >> mas[i].r >> mas[i].s;
    }
    mas[n] = {0, 1, w, h + 2};
    n++;
    sort(mas, mas + n);
    long long a[n];
    fill(a, a + n, 0);
    a[0] = 1;
    for (int i = 0; i < n; i++)
    {
        //cerr << i << endl;
        ins(0, 1, w + 1, mas[i].l, mas[i].r + 1, mas[i].h, mas[i].h + mas[i].s + 1, i);
    }
    //cerr << " 1" << endl;
    init(0, 1, w + 1);
    //cerr << " 2" << endl;
    for (int i = 1; i < n; i++)
    {
        //cerr << "  " << i << endl;
        int x = mas[i].l - 1;
        if (x == 0)
            x = mas[i].r + 1;
        a[i] += a[get(0, 1, w + 1, x, mas[i].h)];
        //cerr << "  " << i << endl;
        x = mas[i].r + 1;
        if (x > w)
            x = mas[i].l - 1;
        a[i] += a[get(0, 1, w + 1, x, mas[i].h)];
        //cerr << "  " << i << endl;
    }
    long long ans = 0;
    for (int i = 1; i <= w; i++)
    {
        ans += a[get(0, 1, w + 1, i, h + 1)];
        //cerr << "   " << i << endl;
    }
    cout << ans % ((long long)1e9 + 7) << endl;
    return 0;
}
