#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second

using namespace std;

const int N = 1000;

string a[N][2];
int pos[N];
vector<int> g[N];
bool used[N];
set<string> del;
string out[N];

void dfs(int u)
{
    used[u] = true;
    bool ok = false;
    rep(i, pos[u], 2)
        if (!del.count(a[u][i]))
        {
            out[u] = a[u][i];
            del.insert(a[u][i]);
            ok = true;
            break;
        }
    if (!ok)
    {
        cout << "NO" << endl;
        exit(0);
    }
    for (int v : g[u])
        if (!used[v])
            dfs(v);
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    int n;
    cin >> n;
    rep(i, 0, n)
    {
        string s, t;
        cin >> s >> t;
        a[i][0] = s.substr(0, 3);
        a[i][1] = s.substr(0, 2) + t[0];
    }
    set<int> s;
    rep(i, 0, n)
        rep(j, 0, n)
            if (i != j && a[i][0] == a[j][0])
            {
                s.insert(i);
                s.insert(j);
                pos[i] = 1;
                pos[j] = 1;
            }
    rep(i, 0, n)
        rep(j, 0, n)
            if (i != j)
                if (a[i][0] == a[j][1] || a[i][1] == a[j][0] || a[i][1] == a[j][1])
                    g[i].push_back(j);
    for (int i : s)
        if (!used[i])
            dfs(i);
    rep(i, 0, n)
        if (!used[i])
            dfs(i);
    cout << "YES" << endl;
    rep(i, 0, n)
        cout << out[i] << endl;
    return 0;
}
