#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;

#define TASK ""
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define for1(i, n) for (int i = 1; i <= (int)n; i++)
#define X first
#define Y second
#define mk make_pair
#define pk push_back
#define all(v) v.begin(), v.end()
#define TIME clock() * 1.0 / CLOCKS_PER_SEC

void solve();

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
	
#endif
	solve();
	return 0;
}

const int MAXN = (int)2e5 + 7;
const int INF = (int)1e9 + 7;

int n;
double x[MAXN], v[MAXN];

bool f(double t){
	double lg = 0, rg = INF;
	forn(i, n){
		double l = x[i] - v[i] * t;
		double r = x[i] + v[i] * t;
		uax(lg, l);
		uin(rg, r);
	}
	return lg <= rg;
}

void solve(){
	scanf("%d", &n);
	forn(i, n){
		scanf("%lf", &x[i]);
	}
	forn(i, n){
		scanf("%lf", &v[i]);
	}
	double l = 0, r = INF;
	forn(it, 200){
		double m = (l + r) / 2;
		if (f(m)){
			r = m;
		}
		else{
			l = m;
		}
	}
	printf("%.15f", l);
}