#include <iostream>
#include <set>

using namespace std;

constexpr int maxn = 1e5;
int x[maxn];
int v[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    double l = 0, r = 1e10, mb;
    while (r-l > 1e-8) {
        mb = (l+r)/2;
        double ml = 1e17, mr = -1e17;
        for (int i = 0; i < n; ++i) {
            ml = min(ml, double(x[i])+v[i]*mb);
            mr = max(mr, double(x[i])-v[i]*mb);
        }
        if (ml < mr) {
            l = mb;
        } else {
            r = mb;
        }
    }
    cout << fixed;
    cout.precision(7);
    cout << l << '\n';
    return 0;
}
