#include <iostream>
#include <vector>

using namespace std;

constexpr int maxn = 3e5;

vector<int> v[maxn];

int col[maxn];

void dfs(int u, int prevc, int cur, int p)
{
    col[u] = cur;
    int k = 0;
    for (auto to: v[u]) {
        if (to != p) {
            while (k == cur || k == prevc) {
                ++k;
            }
            dfs(to, cur, k, u);
            ++k;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n-1; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = max(ans, int(v[i].size())+1);
    }
    cout << ans << '\n';
    dfs(0, -1, 0, -1);
    for (int i = 0; i < n; ++i) {
        cout << col[i]+1 << ' ';
    }
    cout << '\n';
    return 0;
}
