#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

constexpr int maxn = 2e3;

pair<pair<string, string>, int> a[maxn];
string res[maxn];
pair<string, string> b[maxn];

#define fst first
#define snd second

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].fst.fst >> a[i].fst.snd;
        a[i].fst.fst.resize(3);
        a[i].fst.snd.resize(1);
        a[i].fst.snd = a[i].fst.fst.substr(0, 2)+a[i].fst.snd;
        a[i].snd = i;
        b[i].fst = a[i].fst.fst;
        b[i].snd = a[i].fst.snd;
    }
    sort(a, a+n);
    set<string> fbdn;
    for (int i = 0; i < n; ++i) {
        if (i == n-1 || a[i].fst.fst != a[i+1].fst.fst) {
            ;
        } else {
            int j;
            for (j = i; j < n && a[j].fst.fst == a[i].fst.fst; ++j) {
                res[a[j].snd] = a[j].fst.snd;
                fbdn.insert(res[a[j].snd]);
            }
            i = j-1;
        }
    }
    for (;;) {
        bool w = false;
        for (int i = 0; i < n; ++i) {
            if (res[i].length() == 0) {
                if (fbdn.count(b[i].fst) > 0) {
                    res[i] = b[i].snd;
                    fbdn.insert(res[i]);
                    w = true;
                }
            }
        }
        if (!w) {
            break;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (res[i].length() == 0) {
            res[i] = b[i].fst;
            fbdn.insert(res[i]);
        }
    }
    if (int(fbdn.size()) < n) {
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    for (int i = 0; i < n; ++i) {
        cout << res[i] << '\n';
    }
    return 0;
}
