#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

constexpr int maxn = 3e5;

set<int> g1[maxn];

vector<int> g[maxn];

vector<int> path;
bool was[maxn];

void dfs(int v, int p = -1)
{
    path.push_back(v);
    was[v] = 1;
    for (auto to: g[v]) {
        if (!was[to]) {
            dfs(to);
            path.push_back(v);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (a == b) {
            continue;
        }
        g1[a].insert(b);
        g1[b].insert(a);
    }
    for (int i = 0; i < n; ++i) {
        g[i] = vector<int>(g1[i].begin(), g1[i].end());
    }
    dfs(0);
    int u = (((2*n)%k == 0) ? ((2*n)/k) : ((2*n)/k+1));
    int cur = 0;
    int len = int(path.size());
    for (int i = 0; i < k; ++i) {
        int y = min(len-cur, u);
        cout << y << ' ';
        for (int i = 0; i < y; ++i) {
            cout << path[cur++]+1 << ' ';
        }
        cout << '\n';
        if (cur == len) {
            --cur;
        }
    }
    return 0;
}
