#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define eb emplace_back

const int N = 2e5 + 5;

vector<int> go[N];
bool used[N];

vector<int> order;

void dfs(int x) {
    used[x] = true;
    order.pb(x);
    for (int to : go[x]) {
        if (used[to]) continue;
        dfs(to);
        order.pb(x);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        go[x].pb(y);
        go[y].pb(x);
    }
    dfs(1);
    int cnt = (2 * n + k - 1) / k;
    int it = 0;
    for (int i = 0; i < k; i++) {
        vector<int> cur;
        while (it < order.size() && cur.size() < cnt) {
            cur.pb(order[it++]);
            if (cur.size() > 1 && cur.back() == cur[cur.size() - 2]) cur.pop_back();
        }
        if (it == order.size()) it--;
        cout << cur.size() << " ";
        for (int j : cur) cout << j << " ";
        cout << endl;
    }
    return 0;
}
