#include <bits/stdc++.h>

#define mp make_pair
#define pb push_back
#define all(_container) (_container.begin(),_container.end())

#define forn(i,n) for (int (i) = 0; (i) < (int)(n); ++(i))
#define fordn(i,n) for (int (i) = (int)(n) - 1; (i) >= 0; --(i))
#define forkn(i,k,n) for (int (i) = (int)(k); (i) < (int)(n); ++(i))
#define forv(i,_container) for (auto (i) : (_container))

#define OUTPUT "output.txt"
#define INPUT "input.txt"
#define FIN freopen(INPUT,"r",stdin)
#define FOUT freopen(OUTPUT,"w",stdout)

#ifndef HOME
#define FASTIO cin.tie(NULL); ios_base::sync_with_stdio(false);
#define cerr if (0) cerr
#define _DD if (0)
#define DD_
#else
#define FASTIO
#define _DD
#define DD_
#endif

#define MAXN 100100
#define INF 0x3f3f3f3f
#define INFLL 0x3f3f3f3f3f3f3f3fll
#define EPS 1e-7
#define MOD 1'000'000'007
#define HASHMOD 1791791791
#define M_PI 3.14159265359

using namespace std;

typedef int64_t ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pld;
typedef vector<int> vi;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<pll> vpll;
typedef vector<ld> vld;
typedef vector<pld> vpld;

typedef vector<vector<int>> graph;
typedef vector<vector<pii>> wgraph;

int x[MAXN], v[MAXN];

bool check(ld m, int n)
{
    ld l = -1e10, r = 1e10;
    forn(i,n)
        r = min(r,x[i] + v[i] * m),
        l = max(l,x[i] - v[i] * m);
    return (r > l - EPS);
}

int main()
{
    FASTIO

    int n;
    cin >> n;

    forn(i,n)
        cin >> x[i];
    forn(i,n)
        cin >> v[i];

    ld l = 0, r = 1e10;
    while (r - l > EPS)
    {
        ld m = l + (r - l) / 2;
        if (check(m,n))
            r = m;
        else
            l = m;
    }
    cout << fixed << setprecision(8) << r;
}

