#include <bits/stdc++.h>

#define mp make_pair
#define pb push_back
#define all(_container) (_container.begin(),_container.end())

#define forn(i,n) for (int (i) = 0; (i) < (int)(n); ++(i))
#define fordn(i,n) for (int (i) = (int)(n) - 1; (i) >= 0; --(i))
#define forkn(i,k,n) for (int (i) = (int)(k); (i) < (int)(n); ++(i))
#define forv(i,_container) for (auto (i) : (_container))

#define OUTPUT "output.txt"
#define INPUT "input1.txt"
#define FIN freopen(INPUT,"r",stdin)
#define FOUT freopen(OUTPUT,"w",stdout)

#ifndef HOME
#define FASTIO cin.tie(NULL); ios_base::sync_with_stdio(false);
#define cerr if (0) cerr
#define _DD if (0)
#define DD_
#else
#define FASTIO
#define _DD
#define DD_
#endif

#define MAXN 290109
#define INF 0x3f3f3f3f
#define INFLL 0x3f3f3f3f3f3f3f3fll
#define EPS 1e-7
#define MOD 1'000'000'007
#define HASHMOD 1791791791
#define M_PI 3.14159265359

using namespace std;

typedef int64_t ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pld;
typedef vector<int> vi;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<pll> vpll;
typedef vector<ld> vld;
typedef vector<pld> vpld;

typedef vector<vector<int>> graph;
typedef vector<vector<pii>> wgraph;

string s[MAXN];
int h[MAXN];
char city[MAXN];

graph g;

inline void setcity(int v)
{
    city[v] = 1;
    swap(s[v][3],s[v][2]);
    h[v] -= s[v][3];
    h[v] += s[v][2];
}

void dfs(int v)
{
    setcity(v);
    forv(i,g[v])
    {
        if (!city[i])
            dfs(i);
    }
}

int main()
{
    FASTIO
    #ifdef HOME
    FIN;
    #endif // HOME

    int n;
    cin >> n;

    forn(i,n)
    {
        string s1,s2;
        cin >> s1 >> s2;
        s[i] = string(s1.begin(),s1.begin()+3);
        s[i].pb(s2[0]);
        forn(j,3)
            h[i] = (h[i] * 128 + s[i][j]);
    }

    g.resize(n);
    forn(i,n-1)
        forkn(j,i+1,n)
            if (h[i] == h[j])
                city[i] = city[j] = 1;
    forn(i,n)
        if (city[i])
            setcity(i);
    forn(i,n)
        forn(j,n)
        {
            if (i == j)
                continue;
            if ((!city[i]) && (!city[j]) && (h[i] / 128 == h[j] / 128) && s[i][3] == s[j][2])
                g[i].pb(j);
        }
    forn(i,n)
        forn(j,n)
        {
            if (i == j)
                continue;
            if (city[i] && (!city[j]) && h[i] == h[j])
                dfs(j);
        }
    forn(i,n-1)
        forkn(j,i+1,n)
            if (h[i] == h[j])
            {
                cout << "NO" << endl;
                return 0;
            }
    cout << "YES" << endl;
    forn(i,n)
    {
        s[i].pop_back();
        cout << s[i] << endl;
    }
}
