#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <algorithm>
using namespace std;
#define vec vector
#define size(a) ((int)(a).size())
#define forn(i,s,n) for(int (i) = (s); (i) < (n); (i)++)
typedef long long ll;
typedef long double ld;
const ld eps = 1e-9;
vec<ld> xs;
vec<ld> v;
int n;
bool can(ld t)
{
 ld maxl = 1, minr = 1e18;
 forn(i,0,n)
 {
	 maxl = max(maxl, xs[i] - t * v[i]);
	 minr = min(minr, xs[i] + t * v[i]);
 }
 return maxl <= minr;
}
int main()
{
	//freopen("input.txt","r",stdin);
	cin >> n;
	xs.resize(n);
	v.resize(n);
	forn(i,0,n)
		cin >> xs[i];
	forn(i,0,n)
		cin >> v[i];
	ld l = 0, r = 1e9 + 100;
	forn(i,0,90)
	{
		ld m = (r + l) / 2.;
		if(can(m))
			r = m;
		else
			l = m;
	}
	cout << fixed << setprecision(9) << r;
	return 0;
}