#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <algorithm>
using namespace std;
#define vec vector
#define size(a) ((int)(a).size())
#define forn(i,s,n) for(int (i) = (s); (i) < (n); (i)++)
#define pb push_back
typedef long long ll;
typedef long double ld;
const ld eps = 1e-9;
const int N = 2e5;
vec<int> g[N];
int n;
int color[N];
int ans, to;
void dfs(int v, int p = -1)
{
	int badcolor = (p == -1 ? 0 : color[p]);
	int l = 1;
	forn(i,0,size(g[v]))
	{
		to = g[v][i];
		if(to == p)
			continue;
		if(l == badcolor || l == color[v])
			l++;
		if(l == badcolor || l == color[v])
			l++;
		color[to] = l++;
	}
	forn(i,0,size(g[v]))
	{
		to = g[v][i];
		if(to == p)
			continue;
		dfs(to, v);
	}
}
int main()
{
	//freopen("input.txt","r",stdin);
	iostream::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	forn(i,0,n - 1)
	{
		int a,b;
		cin >> a >> b;
		a--,b--;
		g[a].pb(b);
		g[b].pb(a);
	}
	forn(i,0,n)
		ans = max(ans, 1 + size(g[i]));
	color[0] = 1;
	dfs(0);
	cout << ans << '\n';
	forn(i,0,n)
		cout << color[i] << ' ';
	return 0;
}