#include <bits/stdc++.h>

using namespace std;

#define fr first
#define sc second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int maxn = 1e5 + 55;
const int inf = 1e9;
const int base = 1e9 + 9;
const double eps = 1e-7;

double x[maxn], y[maxn];
int n;

bool check(ld m){
    ld l = 0, r = inf;
    for(int i = 0; i < n; i++){
        l = max(l, x[i] - y[i]*m);
        r = min(r, x[i] + y[i]*m);
    }
    if(l <= r)
        return 1;
    return 0;
}

int main()
{
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> x[i];
    for(int i = 0; i < n; i++)
        cin >> y[i];
    ld l = 0;
    ld r = inf, m;
    while(abs(r - l) > eps){
        m = ( l + r)/2;
        if(check(m)){
            r = m;
        }
        else{
            l = m;
        }
    }
    cout << fixed << setprecision(20) << l;
    return 0;
}
