#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define len(a) (int)((a).size())
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define all(a) (a).begin(), (a).end()
#define int long long
#define INF (int)(1e9)

using namespace std;

struct Team {
    string a, b;
    int id;
    Team() = default;
    Team(string s1, string s2, int id) : a(s1.substr(0, 3)), b(s2.substr(0, 1)), id(id) {}
    bool operator<(Team x) const {
        return a < x.a || a == x.a && b < x.b || a == x.a && b == x.b && id < x.id;
    }
};

signed main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<Team> a(n);
    forn(i, n) {
        string s1, s2;
        cin >> s1 >> s2;
        a[i] = Team(s1, s2, i);
    }
    sort(all(a));
    unordered_set<string> s;
    vector<string> ans(n, "");
    forn(i, n - 1) {
        if (a[i].a == a[i + 1].a) {
            if (a[i].b == a[i + 1].b) {
                cout << "NO"; return 0;
            }
            string s1 = a[i].a.substr(0, 2) + a[i].b;
            string s2 = a[i + 1].a.substr(0, 2) + a[i + 1].b;
            if (s.find(s1) != s.end() && ans[a[i].id] == "" || s.find(s2) != s.end() && ans[a[i].id] == "") {
                cout << "NO"; return 0;
            }
            ans[a[i].id] = s1;
            ans[a[i + 1].id] = s2;
            s.insert(s1);
            s.insert(s2);
        }
    }
    bool fl = 1;
    while (fl) {
        fl = 0;
        forn(i, n) {
            if (ans[a[i].id] == "") {
                string s1 = a[i].a;
                string s2 = a[i].a.substr(0, 2) + a[i].b;
                if (s.find(s1) != s.end()) {
                    if (s.find(s2) != s.end()) {
                        cout << "NO"; return 0;
                    }
                    ans[a[i].id] = s2;
                    s.insert(s2);
                    fl = 1;
                }
                else {
                    if (s.find(s2) != s.end()) {
                        ans[a[i].id] = s1;
                        s.insert(s1);
                        fl = 1;
                    }
                    else if (s1 == s2) {
                        ans[a[i].id] = s1;
                        s.insert(s1);
                        fl = 1;
                    }
                }
            }
        }
    }
    forn(i, n) {
        if (ans[a[i].id] == "") {
            ans[a[i].id] = a[i].a;
        }
    }
    cout << "YES" << endl;
    forn(i, n) cout << ans[i] << endl;
    return 0;
}
