#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int n, m;
vector <int> v;
vector <vector <int> > g0, g1;

int main()
{
    v.push_back(0);
    for (int i = 0; i < 22; i++)
    {
        n = (int)v.size();
        for (int j = 0; j < n; j++)
            v.push_back(v[j] ^ 1);
    }
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n >> m;
    g0.resize(n + 1);
    g1.resize(n + 1);
    for (int i = 0; i < m; i++)
    {
        int from, to, type;
        cin >> from >> to >> type;
        if (type == 0)
            g0[from].push_back(to);
        else
            g1[from].push_back(to);
    }

    int step = 0;
    vector <vector <bool> > used(2, vector <bool>(n + 1, false));
    used[0][1] = true;

    int N = 700000000 / (n * n);
    for (int z = 0; z < min((int)v.size() / 2 + 5000, N); z++, step ^= 1)
    {
        bool check = false;

        for (int i = 1; i <= n; i++)
        {
            if (!used[step][i])
                continue;
            if (v[z] == 0)
            {
                for (int j = 0; j < (int)g0[i].size(); j++)
                    check = used[step ^ 1][g0[i][j]] = true;
            }
            else
            {
                for (int j = 0; j < (int)g0[i].size(); j++)
                    check = used[step ^ 1][g0[i][j]] = true;
            }

            used[step][i] = false;
        }

        if (!check)
            return cout << z, 0;
    }

    cout << -1;
    return 0;
}
