#include <bits/stdc++.h>

using namespace std;
const int N = 4e5 + 228;

int p[N];
vector<int> path, pack, g[N];

int get(int x) {
    if(p[x] == x)
        return x;
    return p[x] = get(p[x]);
}

void dfs(int v, int p = -1) {

    path.push_back(v);

    for(int u : g[v]) {
        if(u == p)
            continue;

        dfs(u, v);
        path.push_back(v);
    }
}

int main() {
    ios::sync_with_stdio(false);

    int n, m, k;
    cin >> n >> m >> k;

    for(int i = 1; i <= n; i++) {
        p[i] = i;
    }

    while(m--) {
        int x, y;
        cin >> x >> y;

        if(get(x) != get(y)) {
            g[x].push_back(y);
            g[y].push_back(x);

            p[get(x)] = get(y);
        }
    }

    dfs(1);

    int mx = ((2 * n) / k);

//    for(int u : path) {
//        cout << u << " ";
//    }
//
//    cout << "\n\n\n";
//

    for(int i = 0; i < path.size(); i++) {
        pack.push_back(path[i]);
        if(pack.size() == mx) {
            cout << pack.size() << " ";
            for(int j = 0; j < pack.size(); j++) {
                cout << pack[j] << " ";
            }
            cout << "\n";
            k--;
            pack.clear();
        }
    }

    if(pack.size() > 0) {
        cout << pack.size() << " ";
        for(int j = 0; j < pack.size(); j++) {
            cout << pack[j] << " ";
        }
        cout << "\n";
        k--;
    }

    while(k > 0) {
        cout << 1 << " " << 1 << "\n";
        k--;
    }

    return 0;
}
