#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
const int MAXN = 1e3 * 2 + 50;
const int MAXM = 1e3 * 2 + 50;

map<string, int> mp;
map<int, string> mp_rev;
int mp_sz = 0;

vector<int> g[MAXN];
int mt[MAXM];
bool used[MAXN];

bool kun(int v){
    if (used[v]){
        return false;
    }

    used[v] = true;

    for (auto to : g[v]){
        if (mt[to] == -1 || kun(mt[to])){
            mt[to] = v;
            return true;
        }
    }

    return false;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    pair<string, string> mas[MAXN];

    for (int i = 0; i < n; ++i){
        string a, b;
        cin >> a >> b;

        mas[i].first = a.substr(0, 3);
        mas[i].second = a.substr(0, 2) + b.substr(0, 1);
        //cout << mas[i].first << ' ' << mas[i].second << endl;

        if (mp.count(mas[i].first) == 0){
            mp[mas[i].first] = mp_sz++;
            mp_rev[mp_sz - 1] = mas[i].first;
        }

        if (mp.count(mas[i].second) == 0){
            mp[mas[i].second] = mp_sz++;
            mp_rev[mp_sz - 1] = mas[i].second;
        }
    }


    for (int i = 0; i < n; ++i){
        g[i].push_back(mp[mas[i].second]);

        bool fl = true;

        for (int j = 0; j < n; ++j){
            if (i != j && mas[i].first == mas[j].first){
                fl = false;
                break;
            }
        }

        if (fl){
            g[i].push_back(mp[mas[i].first]);
        }
    }

    for (int i = 0; i < mp_sz; ++i){
        mt[i] = -1;
    }

    for (int i = 0; i < n; ++i){
        for (int j = 0; j < n; ++j){
            used[j] = false;
        }

        kun(i);
    }

    string ans[MAXN];
    int cnt = 0;
    for (int i = 0; i < mp_sz; ++i){
        if (mt[i] != -1){
            ans[mt[i]] = mp_rev[i];
            cnt++;
        }
    }

    if (cnt < n){
        cout << "NO" << endl;
    } else {
        cout << "YES" << endl;

        for (int i = 0; i < n; ++i){
            cout << ans[i] << '\n';
        }

        cout << endl;
    }

    return 0;
}
