#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
const int MAXN = 1e5 * 2 + 100;

int n, m, k;
int max_len;
vector<int> g[MAXN];
vector<int> ans[MAXN];
bool used[MAXN];
int cur_k = 0;
int cur_sz = 0;

void pek(int v){
    if (cur_sz == max_len){
        cur_k++;
        cur_sz = 1;
        ans[cur_k].push_back(v);
    } else {
        ans[cur_k].push_back(v);
        cur_sz++;
    }
}

void dfs(int v){
    used[v] = true;

    pek(v);

    for (auto to : g[v]){
        if (!used[to]){
            dfs(to);
            pek(v);
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m >> k;
    max_len = (2 * n + k - 1) / k;
    for (int i = 0; i < m; ++i){
        int v1, v2;
        cin >> v1 >> v2;
        v1--;
        v2--;

        g[v1].push_back(v2);
        g[v2].push_back(v1);
    }

    for (int i = 0; i < n; ++i){
        used[i] = false;
    }

    dfs(0);

    for (int i = 0; i < k; ++i){
        if (ans[i].size() == 0){
            cout << 1 << ' ' << 1 << endl;
        } else {
            cout << ans[i].size() << ' ';

            for (auto e : ans[i]){
                cout << e + 1<< ' ';
            }
            cout << endl;
        }
    }

    return 0;
}
