#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cstdint>
#include <climits>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <functional>

using namespace std;

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
    #else
		ios_base::sync_with_stdio(false);
    #endif // DEBUG
	static char layer[12][500][500] = {};
	static int dp[12][500][2] = {};
	int last = 0;
    int n, m; cin >> n >> m;
    for (int i = 0; i < 12; i++) {
		for (int j = 0; j < n; j++) {
			for (int k = 0; k < 2; k++) {
				dp[i][j][k] = 0;
			}
			for (int k = 0; k < n; k++) {
				layer[i][j][k] = 0;
			}
		}
    }
    for (int i = 0; i < m; i++) {
        int a, b, c; cin >> a >> b >> c; a--; b--;
        layer[0][a][b] |= (1 << c);
        dp[0][a][c] = 1;
    }
    for (int q = 0; q < 12; q++) {
		if (q == 11) {
			cout << -1 << endl;
			return 0;
		}
		bool ok = false;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (layer[q][i][j]) {
					ok = true;
					break;
				}
			}
		}
		if (!ok) {
			break;
		}
		last = q;
		for (int i = 0; i < n; i++) {
			dp[q+1][i][0] = dp[q][i][0];
			dp[q+1][i][1] = dp[q][i][1];
		}
        for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
                if (layer[q][i][j]) {
					for (int k = 0; k < n; k++) {
						if (layer[q][j][k]) {
							const int rev[4] = {0, 2, 1, 3};
							layer[q+1][i][k] |= layer[q][i][j] & rev[layer[q][j][k]];
							if (layer[q+1][i][k] & 1) {
								dp[q+1][i][0] = max(dp[q+1][i][0], (1 << (q+1)) + dp[q][k][1]);
							}
							if (layer[q+1][i][k] & 2) {
								dp[q+1][i][1] = max(dp[q+1][i][1], (1 << (q+1)) + dp[q][k][0]);
							}
						}
					}
                }
			}
        }
    }
    int res = 0;
    for (int i = 0; i < n; i++) {
		res = max(res, dp[last][i][0]);
    }
	cout << res << endl;
	return 0;
}
