#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <vector>
#	include <string>
#	include <algorithm>
#	include <functional>
#	include <iomanip>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ld DEL = 1e-7;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int n;
	cin >> n;

	vector<pair<int, int>> p(n);
	for (int i = 0; i < n; i++)
		cin >> p[i].first;
	for (int i = 0; i < n; i++)
		cin >> p[i].second;

	sort(p.begin(), p.end());

	ld res = 10000000000;
	ld l = p[0].first, r = p.back().first;

	while (r - l > DEL)
	{
		ld m = (r - l) / 2 + l;

		ld max = 0;
		for (ll i = 0; i < n; i++)
			if (abs(m - p[i].first) / p[i].second > max)
				max = abs(m - p[i].first) / p[i].second;

		ld max_l = 0;
		for (ll i = 0; i < n; i++)
			if (abs(m - DEL - p[i].first) / p[i].second > max_l)
				max_l = abs(m - DEL - p[i].first) / p[i].second;

		if (max_l > max)
			l = m;
		else
			r = m;
	}

	ld max = 0;
	for (ll i = 0; i < n; i++)
		if (abs(l - p[i].first) / p[i].second > max)
			max = abs(l - p[i].first) / p[i].second;

	if (max < res)
		res = max;

	cout << fixed << setprecision(10) << res << endl;
}