#include <bits/stdc++.h>
using namespace std;

#define EPS 1e-7

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector < int > a(n);
    vector < int > v(n);
    for (auto& x : a)
        cin >> x;
    for (auto& x : v)
        cin >> x;
    double left = 0, right = 1000000000;
    while (right - left > EPS)
    {
        double mid = (left + right) / 2;
        double l = (double)a[0] - (double)v[0] * mid, r = (double)a[0] + (double)v[0] * mid;
        for (int i = 1; i < n; ++i)
        {
            l = max(l, (double)a[i] - (double)v[i] * mid);
            r = min(r, (double)a[i] + (double)v[i] * mid);
        }
        if (l <= r)
        {
            right = mid;
        }
        else
        {
            left = mid;
        }
    }
    cout.precision(16);
    cout << right << endl;
    return 0;
}
