#include <bits/stdc++.h>
using namespace std;

#define EPS 1e-7

void dfs(int v, vector < vector < int > >& gr, vector < int >& colors, int cc = 1, int p = -1, int pc = -1)
{
    int color = 1;
    colors[v] = cc;
    for (auto x : gr[v])
    {
        while (color == cc || color == pc)
        {
            ++color;
        }
        if (x != p)
        {
            dfs(x, gr, colors, color++, v, cc);
        }
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector < vector < int > > gr(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        --x, --y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    vector < int > color(n);
    dfs(0, gr, color);
    int res = 0;
    for (auto x : color)
        res = max(res, x);
    cout << res << endl;
    for (auto x : color)
    {
        cout << x << " ";
    }
    cout << endl;
    return 0;
}
