#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <complex>
#include <iomanip>

using namespace std;

vector < vector < int > > g, tran;
vector < int > us, col;


int main(){
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;
	
	vector < double > x(n), v(n);

	for (int i = 0; i < n; i++)
		cin >> x[i];
	for (int i = 0; i < n; i++)
		cin >> v[i];

	double l = 0, r = 1e9;

	for (int i = 0; i < 100; i++) {
		double m = (l + r) / 2;
		double lf = -1e9, rg = 1e9;
		for (int j = 0; j < n; j++) {
			lf = max(lf, x[j] - v[j] * m);
			rg = min(rg, x[j] + v[j] * m);
		}
		if (lf - 1e-6 <= rg)
			r = m;
		else
			l = m;
	}

	cout << fixed <<setprecision(12) << l;

	return 0;
}