#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <complex>

using namespace std;

vector < vector < int > > g;
vector < int > us, col;

void dfs(int v, int forb) {
	us[v] = 1;
	int cl = 0;
	for (int i = 0; i < g[v].size(); i++) {
		int j = g[v][i];
		if (!us[j]) {
			while (cl == forb || cl == col[v])
				cl++;
			col[j] = cl;
			dfs(j, col[v]);
			cl++;
		}
	}
	return;
}

int main(){
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;

	if (n == 1) {
		cout << "1\n1";
		return 0;
	}
	if (n == 2) {
		cout << "2\n1 2";
		return 0;
	}

	g.resize(n);

	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	int mx = 0;
	for (int i = 0; i < n; i++)
		mx = max(mx, (int)g[i].size());

	cout << mx + 1 << '\n';

	us.resize(n, 0);
	col.resize(n, 0);
	dfs(0, -1);

	for (int i = 0; i < n; i++)
		cout << col[i] + 1 << ' ';


	return 0;
}