#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <complex>
#include <bitset>

using namespace std;



int main(){
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector < pair < pair < int, int >, int > > edges(m);

	for (int i = 0; i < m; i++) {
		cin >> edges[i].first.first >> edges[i].first.second >> edges[i].second;
		edges[i].first.first--;
		edges[i].first.second--;
	}
	int MX = 60;
	const int MAXN = 500;
	vector < vector < vector < bitset < MAXN > > > > go(n, vector < vector < bitset < MAXN > > > (MX, vector < bitset < MAXN > > (2)));

	for (int i = 0; i < m; i++)
		go[edges[i].first.first][0][edges[i].second][edges[i].first.second] = 1;

	for (int i = 1; i < MX; i++) {
		for (int j = 0; j < n; j++) {
			for (int t = 0; t < 2; t++) {
				for (int k = 0; k < n; k++) {
					if (go[j][i - 1][t][k])
						go[j][i][t] |= go[k][i - 1][t ^ 1];
				}
			}
		}
	}

	unsigned long long mx = 0;
	const unsigned long long INF = 1e18;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (!go[i][MX - 1][0][j])
				continue;
			if (go[j][MX - 1][1].count()) {
				cout << -1;
				return 0;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		bitset < MAXN > cur;
		cur[i] = 1;
		int ty = 0;
		unsigned long long d = 0;
		for (int j = MX - 1; j >= 0; j--) {
			bitset < MAXN > tr;
			for (int k = 0; k < n; k++) {
				if (!cur[k])
					continue;
				tr |= go[k][j][ty];
			}
			if (tr.count()) {
				cur = tr;
				ty ^= 1;
				d += (1ll << j);
			}
		}
		mx = max(mx, d);
	}
	

	cout << mx;


	return 0;
}