#include <iostream>
#include <vector>

using namespace std;

#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define pii pair <int, int>
const double INF = 1e9 + 7;
const int MAX_IT = 100;


int n;
vector <double> v, x;
double cnt;

bool check(double m) {
	double t1 = 0, t2 = 0;
	for (int i = 0; i < n; ++i) {
		t1 = max((x[i] - m) / v[i], t1);
		t2 = min((x[i] - m) / v[i], t2);
	}
	cnt = t1;
	return (t1 <= -t2);
}


int main() {
	cout.precision(20);
	cin >> n;
	v.resize(n);
	x.resize(n);
	for (auto & i : x)
		cin >> i;
	for (auto & i : v)
		cin >> i;

	double l = -INF, r = INF;
	for (int it = 0; it < MAX_IT; ++it) {
		double m = (l + r) / 2;
		if (check(m)) 
			r = m;
		else
			l = m;
	}
	check(r);
	cout << cnt << endl;
}