#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define endl '\n'
#define fi first
#define se second

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> & p)
{
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (auto & i: arr)
    {
        in >> i;
    }
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (int i = 0; i < (int)arr.size() - 1; ++i)
        out << arr[i] << " ";
    if (arr.size())
        out << arr.back();
    return out;
}

template <typename T1, typename T2>
T1 min(T1 a, T2 b)
{
    return min(a, (T1) b);
}

template <typename T1, typename T2, typename T3>
T1 min(T1 a, T2 b, T3 c)
{
    return min(a, (T1)min(b, c));
}

template <typename T1, typename T2, typename T3, typename T4>
T1 min(T1 a, T2 b, T3 c, T4 d)
{
    return min(min(a, b), min(c, d));
}

template <typename T1, typename T2>
T1 max(T1 a, T2 b)
{
    return max(a, (T1) b);
}

template <typename T1, typename T2, typename T3>
T1 max(T1 a, T2 b, T3 c)
{
    return max(a, (T1)max(b, c));
}

template <typename T1, typename T2, typename T3, typename T4>
T1 max(T1 a, T2 b, T3 c, T4 d)
{
    return max(max(a, b), max(c, d));
}


signed main()
{
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n;
    cin >> n;
    set <int> s;
    int ans = 0;
    for (int i = 0; i < 2 * n; ++i)
    {
        int a;
        cin >> a;
        if (s.count(a))
        {
            s.erase(a);
        }
        else
        {
            s.insert(a);
            ans = max(ans, s.size());
        }
    }
    cout << ans << endl;
    return 0;
}
