#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define endl '\n'
#define fi first
#define se second

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> & p)
{
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (auto & i: arr)
    {
        in >> i;
    }
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (int i = 0; i < (int)arr.size() - 1; ++i)
        out << arr[i] << " ";
    if (arr.size())
        out << arr.back();
    return out;
}

template <typename T1, typename T2>
T1 min(T1 a, T2 b)
{
    return min(a, (T1) b);
}

template <typename T1, typename T2, typename T3>
T1 min(T1 a, T2 b, T3 c)
{
    return min(a, (T1)min(b, c));
}

template <typename T1, typename T2, typename T3, typename T4>
T1 min(T1 a, T2 b, T3 c, T4 d)
{
    return min(min(a, b), min(c, d));
}

template <typename T1, typename T2>
T1 max(T1 a, T2 b)
{
    return max(a, (T1) b);
}

template <typename T1, typename T2, typename T3>
T1 max(T1 a, T2 b, T3 c)
{
    return max(a, (T1)max(b, c));
}

template <typename T1, typename T2, typename T3, typename T4>
T1 max(T1 a, T2 b, T3 c, T4 d)
{
    return max(max(a, b), max(c, d));
}

vector <vector<vector<bool>>> kek;
vector <string> ans;
vector <pair <string, string> > arr;
vector <int> ans_now;
int n;

bool check(int k, int p)
{
    if (ans_now[k] != 0)
    {
        if (ans_now[k] != p)
            return false;
        else
            return true;
    }
    ans_now[k] = p;
    //cout << "v = " << k << endl;
    if (p == 1)
    {
        for (int j = 0; j < n; ++j)
        {
            if (j == k)
                continue;
            if (kek[k][j][0])
            {
                if (!check(j, 2))
                    return false;
            }

            if (kek[k][j][2])
            {
                if (!check(j, 1))
                    return false;
            }
        }
    }
    else
    {
        for (int j = 0; j < n; ++j)
        {
            if (j == k)
                continue;
            if (kek[k][j][0])
            {
                if (!check(j, 2))
                    return false;
            }
            if (kek[k][j][1])
            {
                if (!check(j, 1))
                    return false;
            }

            if (kek[k][j][3])
            {
                if (!check(j, 2))
                    return false;
            }
        }
    }
    if (p == 1)
        ans[k] = arr[k].fi;
    else
        ans[k] = arr[k].se;
    return true;
}


signed main()
{
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    //int n;
    cin >> n;
    vector <pair <string, string> > vec(n);
    cin >> vec;
    arr.resize(n);
    for (int i = 0; i < n; ++i)
    {
        arr[i].fi = string(vec[i].fi.begin(), vec[i].fi.begin() + 3);
        arr[i].se = string(vec[i].fi.begin(), vec[i].fi.begin() + 2);
        arr[i].se.push_back(vec[i].se[0]);
    }
    kek.resize(n, vector <vector <bool>> (n, vector <bool>(4, false)));
    ans.resize(n, " ");
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            if (arr[i].fi == arr[j].fi)
                kek[i][j][0] = true;
            if (arr[i].se == arr[j].se)
                kek[i][j][1] = true;
            if (arr[i].fi == arr[j].se)
                kek[i][j][2] = true;
            if (arr[i].se == arr[j].fi)
                kek[i][j][3] = true;
        }
    }
    /*for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            cout << "i = " << i << " j = " << j << " kek[i][j] = " << kek[i][j] << endl;
        }
    }*/
    for (int i = 0; i < n; ++i)
    {
      //  cout << "i = " <<  i << endl;
        if (ans[i] == " ")
        {
            ans_now.clear();
            ans_now.resize(n, 0);
            if (check(i, 1))
                continue;
            else
            {
                ans_now.clear();
                ans_now.resize(n, 0);
                if (check(i, 2))
                    continue;
                else
                {
                    cout << "NO" << endl;
                    return 0;
                }
            }
        }
    }
    cout << "YES" << endl;
    for (auto s : ans)
        cout << s << endl;
    return 0;
}
