#include <bits/stdc++.h>

using namespace std;

const int N = 500 + 1;
const int M = N * N + 7;

bool u[N][M];

vector <pair <int, int> > g[N];
int ans = 0;

void dfs(int v, int i)
{
    if (i >= M)
    {
        cout << -1 << '\n';
        exit(0);
    }
    if (u[v][i])
    {
        return;
    }
    u[v][i] = true;
    ans = max(ans, i);
    for (auto x : g[v])
    {
        int to = x.first;
        int len = x.second;
        if (len == __builtin_popcount(i) % 2)
        {
            dfs(to, i + 1);
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;
        g[u].push_back({v, t});
    }
    for (int i = 1; i <= n; i++)
    {
        dfs(i, 0);
    }
    cout << ans << '\n';
}
