#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int N = 500 + 1;
const int IT = 63;
unordered_set <int> in[N][2][IT], out[N][2][IT];
ll mx[N][2][IT];
vector <pair <int, int> > g[N];

int main()
{
    ios::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;
        g[u].push_back({v, t});
    }
    for (int i = 1; i <= n; i++)
    {
        for (int it = 0; it < IT; i++)
        {
            in[i][0][it].rehash(n);
            in[i][1][it].rehash(n);
        }
        for (auto x : g[i])
        {
            int to = x.first;
            int len = x.second;
            in[to][len][0].insert(i);
            out[i][len][0].insert(to);
            mx[i][len][1] = 1;
        }
    }
    for (int it = 0; it < IT; it++)
    {
        for (int i = 1; i <= n; i++)
        {
            mx[i][0][it + 1] = max(mx[i][0][it + 1], mx[i][0][it]);
            mx[i][1][it + 1] = max(mx[i][1][it + 1], mx[i][1][it]);
            for (auto a : in[i][0][it])
            {
                mx[a][0][it + 1] = max(mx[a][0][it + 1], (1ll << it) + mx[i][1][it]);
                for (auto b : out[i][1][it])
                {
                    in[b][0][it + 1].insert(a);
                    out[a][0][it + 1].insert(b);
                }
            }
            for (auto a : in[i][1][it])
            {
                mx[a][1][it + 1] = max(mx[a][1][it + 1], (1ll << it) + mx[i][0][it]);
                for (auto b : out[i][0][it])
                {
                    in[b][1][it + 1].insert(a);
                    out[a][1][it + 1].insert(b);
                }
            }
        }
    }
    ll ans = 0;
    for (int it = 0; it < IT; it++)
    {
        ans = max(ans, mx[1][0][it]);
    }
    if (ans > (ll) 1e18)
    {
        cout << -1 << '\n';
        return 0;
    }
    cout << ans << '\n';
}
