#include <bits/stdc++.h>

using namespace std;

void out(int k) {
    string ans;
    ans += (k % 27 + 'A' - 1);
    k /= 27;
    ans += (k % 27 + 'A' - 1);
    k /= 27;
    ans += (k % 27 + 'A' - 1);
    cout << ans[2] << ans[1] << ans[0] << "\n";
}


int main() {
    int n;
    cin >> n;
    vector <int> pos(27 * 27 * 27, -1);
    vector <int> ans(n, -1);
    vector <int> first(n);
    vector <int> second(n);
    queue <int> q;
    for (int i = 0; i < n; ++i) {
        string x, y;
        cin >> x >> y;
        first[i] = (x[0] - 'A' + 1) * 27 * 27 + (x[1] - 'A' + 1) * 27 + x[2] - 'A' + 1;
        pos[first[i]] = i;
        second[i] = (x[0] - 'A' + 1) * 27 * 27 + (x[1] - 'A' + 1) * 27 + y[0] - 'A' + 1;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (first[i] == first[j]) {
                ans[i] = second[i];
                pos[first[i]] = -1;
                ans[j] = second[j];
                q.push(second[i]);
                q.push(second[j]);
            }
        }
    }
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (pos[u] != -1) {
            q.push(second[pos[u]]);
            ans[pos[u]] = second[pos[u]];
            pos[u] = -1;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (ans[i] == -1) ans[i] = first[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (ans[i] == ans[j]) {
                cout << "NO\n";
                exit(0);
            }
        }
    }
    cout << "YES\n";
    for (int i = 0; i < n; ++i) {
        out(ans[i]);
    }
}
