#include <bits/stdc++.h>

using namespace std;
const unsigned long long MOD = 1e9 + 7;
const int INF = (int)2e9 + 7;
const long long LINF = (long long)1e18;
const unsigned long long mod1 = 183453789;
const unsigned long long mod2 = 1234567891;
const int P1 = 337, P2 = 263;

template<typename T>
T input(){
    T ans = 0, m = 1; char c = ' ';
    while (!((c >= '0' && c <= '9') || c == '-')) c = getchar();
    if (c == '-') m = -1, c = getchar();
    while (c >= '0' && c <= '9') ans = ans * 10 + (c - '0'), c = getchar();
    return ans * m;
}

string nextString(bool flag = false){
    char ch; string ans = "";
    do { ch = getchar(); } while(ch <= ' ');
    while(1) {
        ans += ch; ch = getchar();
        if ( (!flag && ch <= ' ') || (flag && ch < ' ') ) break;
    }
    return ans;
}
char nextChar(){
    char ch;
    do {ch = getchar(); } while(ch <= ' ');
    return ch;
}
void read(string& s){ s = nextString(); }
void read(char& c){ c = nextChar(); }
template<typename T> void read(T& a){ a = input<T>(); }
template<typename T, typename... R> void read(T& a, R&... r){ read(a); read(r...); }

void ex(){
    cout << "NO\n";
    exit(0);
}

const int N = 1e3 + 10;

map < string, vector < pair < string, int > > > m;
string ans[N];
map < string, bool > u;

struct node {
    int id;
    string f, s;
    node () {}
    node(int id, const string& f, const string& s){
        this->id = id;
        this->f = f;
        this->s = s;
    }
};

int32_t main() {
    ios_base::sync_with_stdio(0);  cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n; read(n);
    for (int i = 0; i < n; ++ i){
        string s1, s2;
        read(s1, s2);

        string F; F += s1[0]; F += s1[1]; F += s1[2];
        string S; S += s1[0]; S += s1[1]; S += s2[0];
        m[F].push_back({S, i});
    }
    for (auto& e: m){
        const auto& v = e.second;
        if (v.size() == 1) continue;
        for (auto& t: v){
            ans[t.second] = t.first;
            u[t.first] = true;
        }
    }
    vector < node > vec;
    for (auto& e: m){
        const auto& v = e.second;
        if (v.size() > 1) continue;
        const string& f = e.first, s = v[0].first;
        int id = v[0].second;
        if (u[f]){
            u[s] = true;
            ans[id] = s;
        } else {
            if (u[s]){
                ans[id] = f;
                u[f] = true;
            } else {
                vec.emplace_back(id, f, s);
            }
        }
    }
    for (auto& nd: vec){
        ans[nd.id] = nd.f;
    }

    //output
    for (int i = 0; i < n; ++ i){
        for (int j = 0; j < i; ++ j){
            if (ans[i] == ans[j])
                ex();
        }
    }
    cout << "YES\n";
    for (int i = 0; i < n; ++ i){
        cout << ans[i] << "\n";
    }
}
