#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<map>
#include<set>
#include<queue>

using namespace std;

typedef int int32_t;
#define int long long

struct team {
	char a, b;
	int id;
	team() {}
	team(char a, char b, int id) : a(a), b(b), id(id) {}
	bool operator<(const team& t) const {
		if (a != t.a)
			return a < t.a;
		return b < t.b;
	}
	bool equal(team& t) {
		return (a == t.a) && (b == t.b);
	}
};

map<string, vector<team> > mp;
vector<char> ans; 
vector<string> base;

void no() {
	cout << "NO\n";
	exit(0);
}

bool bad(vector<string> &base, vector<char> &ans, int n) {
	set<string> u;
	for (int i = 0; i < n; i++)
		u.insert(base[i] + ans[i]);
	return u.size() != n;
}

int32_t main() {
	//freopen("input.in", "r", stdin);

	int n;
	cin >> n;
	string a, b;
	ans.resize(n);
	base.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a >> b;
		string k(a.begin(), a.begin() + 2);
		base[i] = k;
		mp[k].push_back(team(a[2], b[0], i));
	}

	for (map<string, vector<team> >::iterator it = mp.begin(); it != mp.end(); it++) {
		vector<team> &w = it->second;
		sort(w.begin(), w.end());
		for (int i = 1; i < w.size(); i++) {
			if (w[i].equal(w[i - 1]))
				no();
		}

		map<char, vector<team> > sp;
		for (int i = 0; i < w.size(); i++)
			sp[w[i].a].push_back(w[i]);
		queue<char> forb;
		map<char, bool> was;
		for (map<char, vector<team> >::iterator iter = sp.begin(); iter != sp.end(); iter++) {
			vector<team> &kek = iter->second;
			if (kek.size() > 1) {
				for (int i = 0; i < kek.size(); i++) {
					ans[kek[i].id] = kek[i].b;
					forb.push(kek[i].b);
					was[kek[i].b] = true;
				}
			}
			else
				ans[kek[0].id] = kek[0].a;
		}
		while (!forb.empty()) {
			int c = forb.front();
			forb.pop();
			if (!sp.count(c))
				continue;
			team &t = sp[c][0];
			ans[t.id] = t.b;
			if (!was[t.b]) {
				forb.push(t.b);
				was[t.b] = true;
			}
		}
	}
	
	if (bad(base, ans, n))
		no();

	cout << "YES\n";
	for (int i = 0; i < n; i++)
		cout << base[i] << ans[i] << "\n";
}