#include <bits/stdc++.h>

using namespace std;

#define rep(i,a,n) for(int (i)=(a);(i)<(n);++(i))
#define per(i,a,n) for(int (i)=(n)-1;(i)>=(a);--(i))
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
#define SZ(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef vector<pii> vpii;

template <typename T>
T getint(){
    T x=0,p=1;
    char ch;
    do{ch=getchar();}while(ch<=' ');
    if(ch=='-')p=-1,ch=getchar();
    while(ch>='0'&&ch<='9'){
        x=x*10+ch-'0';ch=getchar();
    }
    return x*p;
}

mt19937 gen(std::chrono::system_clock::now().time_since_epoch().count());

template <typename T1,typename T2> bool umin(T1 &x, const T2&y) { if(x>y)return x=y,true; return false;}
template <typename T1,typename T2> bool umax(T1 &x, const T2&y) { if(x<y)return x=y,true; return false;}

const int maxn=(int)1e5+10;
const int inf=(int)1e9+5;
const int mod=(int)1e9+7;
const ll llinf=(ll)1e18+1;
const ld pi=acos(-1.0);

set<pii> t[4*maxn];
map<pii,int> cnt;
int h,w,n;

void add(int v,int idx,pii x,int tl,int tr){
    t[v].insert(x);
    if(tl==tr)return;
    int tm=(tl+tr)/2;
    if(idx<=tm)add(v+v,idx,x,tl,tm);
    else add(v+v+1,idx,x,tm+1,tr);
}
void del(int v,int idx,pii x,int tl,int tr){
    t[v].erase(x);
    if(tl==tr)return;
    int tm=(tl+tr)/2;
    if(idx<=tm)del(v+v,idx,x,tl,tm);
    else del(v+v+1,idx,x,tm+1,tr);
}

void add(int x,int y){
    add(1,y,mp(x,y),1,w);
}

pii getmax(int v,int l,int r,int tl,int tr){
    if(tl>r||tr<l)return mp(-inf,-1);
    if(l<=tl&&tr<=r){
        if(t[v].empty())return mp(-inf,-1);
        return *--t[v].end();
    }
    int tm=(tl+tr)/2;
    return max(getmax(v+v,l,r,tl,tm),getmax(v+v+1,l,r,tm+1,tr));

}

pii z;

bool have(int x,int l,int r){
    z=getmax(1,l,r,1,w);
    if(z.fi>=x)return true;
    return false;
}

void addd(int &x,int y){
    x+=y;
    if(x>=mod)x-=mod;
}

struct my {
    int h,l,r,s;
    bool operator < (const my &x) const {
        return h<x.h;
    }
} a[maxn];

int main() {
  //  freopen("input.txt","r",stdin);
  //  freopen("output.txt","w",stdout);

    ios_base::sync_with_stdio(0);

    cin>>h>>w>>n;
    rep(i,0,n){
        cin>>a[i].h>>a[i].l>>a[i].r>>a[i].s;
        a[i].h=h-a[i].h+1;
    }
    sort(a,a+n);

    rep(i,1,w+1){
        cnt[mp(0,i)]=1;
        add(0,i);
    }

    rep(i,0,n){
        int h=a[i].h;
        int l=a[i].l;
        int r=a[i].r;
        int s=a[i].s;
        int a1=(l>1?l-1:r+1);
        int a2=(r<w?r+1:l-1);
        while(have(h-s,l,r)){
            addd(cnt[mp(h,a1)],cnt[z]);
            addd(cnt[mp(h,a2)],cnt[z]);
            cnt.erase(cnt.find(z));
            del(1,z.se,z,1,w);
        }
        add(h,a1);
        if(a1!=a2)add(h,a2);
    }
    int res=0;
    for(auto x:cnt)addd(res,x.se);
    cout<<res<<endl;
    return 0;
}
