#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <stdio.h>
#include <string>
#include <numeric>

using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = numeric_limits<ll>::max() / 2 - 1;
const ll mod = 1000000007;
const ld eps = 1e-8;
const ll maxn = 200001;
ll n;
vector<ll> edges[maxn];
ll color[maxn];
ll ans = 1;

void dfs(ll v, ll p, ll col, ll zapr) {
	color[v] = col;
	ans = max(ans,col);
	ll cur = 1;
	for(int i=0;i<edges[v].size();i++) {
		if(edges[v][i]==p) continue;
		while(cur==col || cur==zapr) cur++;
		dfs(edges[v][i],v,cur,col);
		cur++;
	}
}


int run() {
	cin >> n;
	for(int i=0;i<n-1;i++) {
		ll a,b;
		cin >> a >> b;
		a--;
		b--;
		edges[a].push_back(b);
		edges[b].push_back(a);
	}
	dfs(0,-1,1,-1);
	cout << ans << endl;
	for(int i=0;i<n;i++) cout << color[i] << " ";
	return 0;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else

#endif
	run();
	return 0;
}