#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <stdio.h>
#include <string>
#include <numeric>
#include <stdlib.h>

using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = numeric_limits<ll>::max() / 2 - 1;
const ll mod = 1000000007;
const ld eps = 1e-8;
const ll maxn = 512;
ll n,m;
bool is[2][maxn][maxn];
bool isall[maxn][maxn];
bool cur[2][maxn];

const ll sizetui = 10000000;
bool tue[sizetui];

void build(int r) {
	if(r*2> sizetui) return;
	for(int i=0;i<r;i++) {
		tue[r+i] = !tue[i];
	}
	build(r*2);
}

int used[maxn];

bool dfs(int v) {
	if(used[v]==2) return false;
	if(used[v]==1) return true;
	used[v] = 1;
	for(int i=0;i<n;i++) {
		if(isall[v][i] && dfs(i)) return true; 
	}
	return false;
}

int run() {
	build(1);
	cin >> n >> m;
	for(int i=0;i<n;i++) {
		cur[0][i] = cur[1][i] = 1;
	}
	for(int i=0;i<m;i++) {
		ll a,b,c;
		cin >> a >> b >> c;
		a--;
		b--;
		is[c][a][b] = 1;
	}
	for(int i=0;i<n;i++) {
		for(int j=0;j<n;j++) {
			if(is[0][i][j] && is[1][i][j]) isall[i][j] = 1;
		}
	}
	for(int i=0;i<n;i++) {
		if(dfs(i)) {
			cout << -1;
			return 0;
		}
	}
	ll q = 0;
	for(q=0;;q++) {
		int c = (q & 1);
		for(int i=0;i<n;i++) cur[!c][i] = 0;
		bool flag = false;
		for(int i=0;i<n;i++) {
			if(cur[c][i]) {
				flag = true;
				for(int j=0;j<n;j++) {
					if(is[tue[q]][i][j]) cur[!c][j] = 1;
				}
			}
		}
		if(!flag) break;
	}
	cout << q - 1;
	return 0;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else

#endif
	run();
	return 0;
}