#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;

typedef pair < int, int > pi;

const int MAX_N = (int)1e5 + 123;

pi a[MAX_N];
int n;

bool check(double x) {
    double l = 0.0, r = 1e18;
    for (int i = 1; i <= n; i++) {
       double nl = max(0.0, 1.0 * a[i].f - 1.0 * a[i].s * x);
       double nr = 1.0 * a[i].f + 1.0 * a[i].s * x;
       if (nr < l || r < nl)
        return 0;
       l = max(l, nl), r = min(r, nr);
    }
    return 1;
}

int main() {
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i].f;
    for (int i = 1; i <= n; i++)
        cin >> a[i].s;
    sort(a + 1, a + n + 1);
    double l = 0, r = 1e12, mid, best = -1.0;
    for (int it = 0; it < 200; it++) {
        mid = (l + r) / 2.0;
        if (check(mid))
            r = mid;
        else
            l = mid;
    }
    printf("%.12f", l);
    return 0;
}
