#include <bits/stdc++.h>

using namespace std;

#define forn(i, x, n) for (int i = int(x); i <= int(n); ++i)
#define for1(i, n, x) for (int i = int(n); i >= int(x); --i)
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair <ll, ll> PII;
typedef long double ld;
typedef vector <int> vi;

const int N = 2e6 + 10;
const int INF = 1e9 + 9;
const int B = 1e9 + 7;

int n;
PII a[N];
int x[N];

bool ok(ld t) {
    ld l = 0, r = 1e18;
    forn(i, 1, n) {
        ld d = t * a[i].S;
        l = max(l, a[i].F - d);
        r = min(r, a[i].F + d);
    }
    return l <= r;
}

int main() {
    #ifdef black
    freopen("in", "r", stdin);
    #endif // black
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    forn(i, 1, n)
        cin >> a[i].F;
    forn(i, 1, n)
        cin >> a[i].S;
    sort(a + 1, a + 1 + n);
    forn(i, 1, n) x[i] = a[i].F;

    ld l = 0, r = 1e18;
    forn(i, 1, 200) {
        ld m = (l + r) / 2;
        if (ok(m)) r = m; else l = m;
    }
    cout << fixed << setprecision(10) << l << "\n";

    return 0;
}
