#include <bits/stdc++.h>

using namespace std;

#define forn(i, x, n) for (int i = int(x); i <= int(n); ++i)
#define for1(i, n, x) for (int i = int(n); i >= int(x); --i)
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair <ll, ll> PII;
typedef long double ld;
typedef vector <int> vi;

const int N = 2e6 + 10;
const int INF = 1e9 + 9;
const int B = 1e9 + 7;

int n;
vector <int> g[N];
int c[N];

void dfs(int x, int p = -1) {
    if (g[x].size() == 1 && p > 0) {
        c[x] = 1;
        return;
    }
    for (auto to : g[x])
        if (to != p) dfs(to, x);
    sort(g[x].begin(), g[x].end(), [](int a, int b) {
         return c[a] < c[b];
    });
    int cur = c[g[x][0]] - 1;
    for (auto to : g[x]) {
        if (to == p) continue;
        if (c[to] <= cur) c[to] = ++cur;
        else cur = c[to];
    }
    c[x] = ++cur;
}

int main() {
    #ifdef black
    freopen("in", "r", stdin);
    #endif // black
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    forn(i, 1, n - 1) {
        int f, t;
        cin >> f >> t;
        g[f].pb(t);
        g[t].pb(f);
    }
    dfs(1);
    set <int> st;
    forn(i, 1, n) st.insert(c[i]);
    cout << st.size() << "\n";
    forn(i, 1, n)
        cout << c[i] << " ";

    return 0;
}

