#include <bits/stdc++.h>

using namespace std;

#define forn(i, x, n) for (int i = int(x); i <= int(n); ++i)
#define for1(i, n, x) for (int i = int(n); i >= int(x); --i)
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair <ll, ll> PII;
typedef long double ld;
typedef vector <int> vi;

const int N = 2e6 + 10;
const int INF = 1e9 + 9;
const int B = 1e9 + 7;

int n;
vector <int> g[N];
int c[N];

vi dfs(int x, int p = -1, int k = 0) {
    vi ans, t;
    if (g[x].size() == 1 && p > 0) {
        c[x] = k;
        return vi(1, k);
    }
    int cnt = 1;
    for (auto to : g[x])
        if (to != p) {
            vi v = dfs(to, x, cnt++);
            if (t.size() < v.size()) t.swap(v);
            for (auto y : v) t.pb(y);
            v.clear();
            ans.pb(c[to]);
        }
    sort(t.begin(), t.end());
    t.resize(unique(t.begin(), t.end()) - t.begin());
    int l = 1, r = t.size();
    if (t.back() == t.size()) l = r + 1;
    while (l < r) {
        int m = (l + r) >> 1;
        if (t[m - 1] == m) l = m + 1; else r = m;
    }
    c[x] = l;
    ans.pb(c[x]);
    return ans;
}

int main() {
    #ifdef black
    freopen("in", "r", stdin);
    #endif // black
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    forn(i, 1, n - 1) {
        int f, t;
        cin >> f >> t;
        g[f].pb(t);
        g[t].pb(f);
    }
    dfs(1);
    set <int> st;
    forn(i, 1, n) st.insert(c[i]);
    cout << st.size() << "\n";
    forn(i, 1, n)
        cout << c[i] << " ";

    return 0;
}


