#include <bits/stdc++.h>
using namespace std;

queue<int> t;

const int maxn = 2e5;

vector<int> g[maxn];

bool used[maxn];

int dfs(int v, int p){
    used[v] = 1;
    t.push(v);
    for(int u : g[v])
        if(u != p && !used[u])
            dfs(u, v);
    if(p != -1) t.push(p);
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    while(m--){
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(0, -1);

    int r = k;

    vector<int> ans;
    while(t.size()){
        int v = t.front();
        t.pop();
        ans.push_back(v);
        if(ans.size() == (2*n+k-1)/k || t.empty()){
            cout << ans.size();
            for(int x : ans) cout << " " << x+1;
            cout << "\n";
            ans.clear();
            r--;
        }
    }

    while(r--) cout << "1 1\n";

    return 0;
}
