#include <bits/stdc++.h>
using namespace std;

const int maxn = 512;

typedef bitset<maxn> t;

t a[maxn], b[maxn];

bool q[100000000];

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    clock_t start = clock();

    int n, m;
    cin >> n >> m;

    while(m--){
        int u, v, type;
        cin >> u >> v >> type;
        u--, v--;
        if(type == 0) a[u][v] = 1;
        else b[u][v] = 1;
    }

    for(int l = 1; (1<<l) < 100000000; l++)
        for(int i = (1<<(l-1)); i < (1<<l); i++)
            q[i] = !q[i-(1<<(l-1))];

    int ans = 0;

    t p;
    for(int i = 0; i < n; i++)
        p[i] = 1;
    bool fin = 0;
    while( double(clock()-start) < 4.9*CLOCKS_PER_SEC){
        t r;
        for(int i = 0; i < n; i++){
            if(p[i]){
                if(q[ans]) r |= b[i];
                else r |= a[i];
            }
        }
        if(r.count() == 0){
            fin = 1;
            break;
        }
        p = r;
        ans++;
    }

    if(fin) cout << ans;
    else cout << -1;

    return 0;
}
