#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second

using namespace std;

const int N = 200000;

vector<int> g[N];
int out[N];

void dfs(int u, int p, set<int> &c, int c1)
{
    auto it = c.begin();
    for (int v : g[u])
        if (v != p)
        {
            out[v] = *it;
            it++;
        }
    for (int v : g[u])
        if (v != p)
        {
            c.erase(out[v]);
            if (c1 != -1)
                c.insert(c1);
            dfs(v, u, c, out[u]);
            if (c1 != -1)
                c.erase(c1);
            c.insert(out[v]);
        }
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    int n;
    cin >> n;
    rep(i, 0, n - 1)
    {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int ans = 0;
    rep(i, 0, n)
        ans = max(ans, sz(g[i]) + 1);
    set<int> c;
    rep(i, 1, ans)
        c.insert(i);
    out[0] = 0;
    dfs(0, -1, c, -1);
    cout << ans << endl;
    rep(i, 0, n)
        cout << out[i] + 1 << " ";
    return 0;
}
