#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second

using namespace std;

const int N = 200000;

vector<int> g[N];
bool used[N];
vector<int> order;

void dfs(int u)
{
    used[u] = true;
    order.push_back(u);
    for (int v : g[u])
        if (!used[v])
        {
            dfs(v);
            order.push_back(u);
        }
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    int n, m, k;
    cin >> n >> m >> k;
    rep(i, 0, m)
    {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0);
    int len = (2 * n + k - 1) / k;
    fill(used, used + n, false);
    vector<int> ans[k];
    int pos = 0;
    rep(i, 0, k)
    {
        while (pos < sz(order) && used[order[pos]])
            pos++;
        if (pos == sz(order))
        {
            ans[i].push_back(0);
            continue;
        }
        deque<int> q;
        q.push_back(order[pos]);
        pos++;
        int l = len - 1;
        while (pos < sz(order) && l)
        {
            if (q.front() == order[pos])
            {
                q.pop_front();
                l++;
            }
            q.push_back(order[pos]);
            l--;
            pos++;
        }
        while (!q.empty())
        {
            ans[i].push_back(q.front());
            q.pop_front();
        }
    }
    rep(i, 0, k)
    {
        cout << sz(ans[i]) << " ";
        for (int j : ans[i])
            cout << j + 1 << " ";
        cout << endl;
    }
    return 0;
}
