#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second

using namespace std;

const int N = 500;

int n;
bitset<N> to[61][N][2];
ll dist[61][N][2];

ll dfs(int u, int x, int t)
{
    if (dist[x][u][t] != -1)
        return dist[x][u][t];
    ll res = 0;
    rep(i, 0, n)
        if (to[x][u][t].test(i))
        {
            if (x == 0)
                res = max(res, (1LL << x));
            else
                res = max(res, (1LL << x) + dfs(i, x - 1, 1 - t));
        }
    if (x > 0)
        res = max(res, dist[x - 1][u][t]);
    dist[x][u][t] = res;
    return res;
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    int m;
    cin >> n >> m;
    rep(i, 0, m)
    {
        int u, v, t;
        cin >> u >> v >> t;
        u--; v--;
        to[0][u][t].set(v);
    }
    rep(x, 1, 61)
        rep(i, 0, n)
            rep(t, 0, 2)
                rep(j, 0, n)
                    if (to[x - 1][i][t].test(j))
                        to[x][i][t] |= to[x - 1][j][1 - t];
    rep(x, 0, 61)
        rep(i, 0, n)
            rep(t, 0, 2)
                dist[x][i][t] = -1;
    ll len = 0;
    rep(x, 0, 61)
        rep(i, 0, n)
            rep(t, 0, 2)
                dfs(i, x, t);
    rep(x, 0, 61)
        len = max(len, dist[x][0][0]);
    if (len > 1000000000000000000LL)
        cout << -1;
    else
        cout << len;
    return 0;
}
