#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
#define mp push_back
#define all(a) a.begin(), a.end()
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)

using namespace std;

typedef long long base;
typedef pair <int, int> point;

const string FILENAME = "input";
const int MAXN = 2e5 + 1;

int n, m, k, c;
bool used[MAXN];
vector <int> edge[MAXN];
set <int> cnt[MAXN];
int d[MAXN], p[MAXN];
set <pair <int, int>> need;
vector <int> ans[MAXN];
bool res[MAXN];

void dfs(int i, int h = 0, int p = -1) {
	res[i] = true;
	::p[i] = p;
	d[i] = h;
	need.insert(make_pair(-h, i));
	for (int j: edge[i]) {
		if (res[j]) continue;
		dfs(j, h + 1, i);
		cnt[i].insert(j);
	}
}

void clear(int i) {
	if (used[i]) return;
	used[i] = true;
	need.erase(make_pair(-d[i], i));
	if (p[i] != -1) cnt[p[i]].erase(i);
}

void go_dfs(int i, int s, int c) {
	ans[s].pb(i);
	clear(i);
	if (c == 1) return;
	if (cnt[i].size() == 0) {
		if (p[i] != -1) {
			go_dfs(p[i], s, c - 1);
		}
		return;
	}
	go_dfs(*cnt[i].begin(), s, c - 1);
}

int main() {
	ios::sync_with_stdio(0);
	//read(FILENAME);
	cin >> n >> m >> k;
	c = (2 * n + k - 1) / k;
	for (int i = m; i--;) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		edge[a].pb(b);
		edge[b].pb(a);
	}
	dfs(0);
	for (int i = 0; i < k; ++i) {
		if (need.size()) {
			auto s = *need.begin();
			go_dfs(s.y, i, c);
		} else {
			go_dfs(0, i, c);
		}
	}
	assert(need.size() == 0);
	for (int i = 0; i < k; ++i) {
		cout << ans[i].size() << ' ';
		for (int j: ans[i]) {
			cout << j + 1 << ' ';
		}
		cout << '\n';
	}
}
