#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;

#define TASK ""
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define for1(i, n) for (int i = 1; i <= (int)n; i++)
#define X first
#define Y second
#define mk make_pair
#define pk push_back
#define all(v) v.begin(), v.end()
#define TIME clock() * 1.0 / CLOCKS_PER_SEC

void solve();

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
	
#endif
	solve();
	return 0;
}

const int MAXN = (int)5e2 + 7;
const int INF = (int)1e9 + 7;
const int LOGN = 61;
const ll LINF = (ll)1e18;

bool matr[MAXN][MAXN][2], up[MAXN][MAXN][2][LOGN];

void solve(){
	int n, m;
	scanf("%d%d", &n, &m);
	forn(_, m){
		int u, v, t;
		scanf("%d%d%d", &u, &v, &t);
		matr[u][v][t] = true;
	}
	for1(u, n){
		for1(v, n){
			forn(t, 2){
				up[u][v][t][0] = (matr[u][v][t] ? true : false);
			}
		}
	}

	for (int j = 1; j < LOGN; j++){
		for1(u, n){
			for1(v, n){
				for1(w, n){
					forn(t, 2){
						up[u][v][t][j] |= (up[u][w][t][j - 1] && up[w][v][!t][j - 1]);
					}
				}
			}
		}
	}
	
	vi tmp; int t = 0; ll dist = 0;
	tmp.pk(1);
	for (int j = LOGN - 1;j >= 0; j--){
		vi buf;
		forn(i, tmp.size()){
			int u = tmp[i];
			for1(v, n){
				if (up[u][v][t][j]){
					buf.pk(v);
				}
			}
		}
		sort(all(buf));
		buf.resize(unique(all(buf)) - buf.begin());
		if (!buf.empty()){
			t = !t;
			tmp = buf;
			dist += 1ll << j;
		}
	}
	cout << (dist > LINF ? -1 : dist);
}